
\r  polmodG24.gp
\r  représentants.gp



/*   Notations

Invariants pour D=2
J1=G2^2/H4
J3=G2*H6/H4^2
 (J2=G2*H4/H6)

Invariants pour D=5
J2=G2^5/theta10
J4=theta6*G2^2/theta10
 (J1=theta6/G2^3)
*/



/*
JGundlach(Z)              calcule J2 et J4 de Z=[z1,z2]
JGundlach2(Z,N)           idem, beaucoup plus lent
JGundlachNiv2(Z,L1,L2)
JGundlachNiv22(Z,N) 
GundToIg(J2,J4)           calcule j1,j2,j3 (igusa) à partir de J2,J4
GundToIgNiv2(J1,J2)
IgToGund(III)             calcule J2 J4 à partir de j1,j2,j3 (igusa)
IgToGundNiv2(III,L1,L2)

OmegaFromIg(III)          calcule Om tel que Jinv(Om)==III
TauToOmegaNiv5(Z)             morphisme H_1^2 vers H_2; de tau=(z1,z2) à Omega
OmegaToTauNiv5(Omega)         morphisme H_2 vers H_1^2
TauToOmegaNiv2(Z)
OmegaToTauNiv2(Omega)         
taufromgundNiv5(J2,J4)        calcule (z1,z2) tels que JGund(z1,z2)==[J2,J4]
taufromgundNiv2(J1,J2)

polgund 
polthet
*/






/************* Evaluation des invariants de Gundlach   **********************/


\\ Evaluation par série pour D=5
bt(a,b)=
{my(normab,t,PP,m,divnorm,l,B2,B6,B10,F,numfactor,S,multiplier,whichideals,r,i1,i2,I2,d,L,x);
x='x;
d=5;
L=nfinit(x^2-d);

normab=a^2+a*b-b^2;
t=a+b*((1-Mod(x,x^2-d))/2);
PP=idealfactor(L,t);
m=matsize(PP);
divnorm=divisors(normab);
l=length(divnorm);
B2=1;
B6=1;
B10=1;
for(i=2,l, 
   F=factor(divnorm[i]);
   numfactor=matsize(F)[1]; 
   S=1;
   for(j=1,numfactor,
      if(kronecker(F[j,1],d)==-1,
         if(Mod(F[j,2],2)==1,S=0));
      if(kronecker(F[j,1],d)==1,
         whichideals=vector(2,i,0);
         r=1;
         for(n=1,m[1],
            if(PP[n,1][1]==F[j,1],whichideals[r]=n;r=r+1)); 
         if(whichideals[2]==0,multiplier=1,
            i1=PP[whichideals[1],2];
            i2=PP[whichideals[2],2];
            I2=min(i1,i2);
            if(F[j,2]<I2,multiplier=F[j,2]+1,
               if(F[j,2]>max(i1,i2),multiplier=(i1+i2-F[j,2])+1,multiplier=I2+1)));
         S=S*(multiplier)));

 B2=B2+S*divnorm[i];
 B6=B6+S*divnorm[i]^5;
 B10=B10+S*divnorm[i]^9;
);

return([B2,B6,B10]);
}


Gk(z1,z2,N)= 
{my(q1,q2,K2,K6,K10,s);


K2=2^3*3*5;                   \\=Kappa(2)
K6=1/67*2^3*3^2*5*7;          \\Kappa(6);
K10=1/412751*2^3*3*5^2*11;    \\Kappa(10);
q1=exp(2*I*Pi*((1+sqrt(5))*z1/(2*sqrt(5))-(1-sqrt(5))*z2/(2*sqrt(5))));
q2=exp(2*I*Pi*(z2-z1)/sqrt(5));


s=sum(a=1,N,q1^a*(sum(b=0,floor(((1+sqrt(5))/2)*a), bt(a,b)*q2^b)+   
                       sum(b=1,floor(-((1-sqrt(5))/2)*a),bt(a,-b)*q2^(-b))));
return([1+K2*s[1],1+K6*s[2],1+K10*s[3]]);
}




\\ Evaluation par série pour D=2

bt2(a,b)=
{my(normab,t,PP,m,divnorm,l,F,numfactor,S,multiplier,whichideals,r,i1,i2,I2,B2,B4,B6,x);
my(L,d);
d=2;
x='x;
L=nfinit(x^2-d);

normab=a^2+2*a*b-b^2;
t=a+b*(1-Mod(x,x^2-d));

PP=idealfactor(L,t);
m=matsize(PP);
divnorm=divisors(normab);
l=length(divnorm);
B2=1;
B4=1;
B6=1;
for(i=2,l,
   F=factor(divnorm[i]);
   numfactor=matsize(F)[1];
   S=1;
   for(j=1,numfactor,
      if(kronecker(F[j,1],d)==-1,
         if(Mod(F[j,2],2)==1,S=0));
      if(kronecker(F[j,1],d)==1,
         whichideals=vector(2,i,0);
         r=1;
         for(n=1,m[1],
            if(PP[n,1][1]==F[j,1],whichideals[r]=n;r=r+1));
         if(whichideals[2]==0,multiplier=1,
            i1=PP[whichideals[1],2];
            i2=PP[whichideals[2],2];
            I2=min(i1,i2);
            if(F[j,2]<I2,multiplier=F[j,2]+1,
               if(F[j,2]>max(i1,i2),multiplier=(i1+i2-F[j,2])+1,multiplier=I2+1)));
         S=S*(multiplier)));
 B2=B2+S*abs(divnorm[i]);
 B4=B4+S*abs(divnorm[i])^3;
 B6=B6+S*abs(divnorm[i])^5;

);

return([B2,B4,B6]);
}


/*
Gk2(Z,N)=  \\renvoie G2, G4, G6
{my(K2,K4,K6,s,q1,q2);

K2=2^4*3;               \\Kappa(2)
K4=2^5*3*5/11;          \\Kappa(4);
K6=2^4*3^2*7/19^2;      \\Kappa(6);

q1=exp(I*Pi*((1+sqrt(2))*Z[1]/sqrt(2)-(1-sqrt(2))*Z[2]/sqrt(2)));
q2=exp(I*Pi*(Z[2]-Z[1])/sqrt(2));

s=sum(a=1,N,q1^a*(sum(b=0,floor((1+sqrt(2))*a), bt2(a,b)*q2^b)+
                       sum(b=1,floor(-(1-sqrt(2))*a),bt2(a,-b)/q2^b)));
return([1+K2*s[1],1+K4*s[2],1+K6*s[3]]);
}
*/

Gk2(Z,N)=  \\renvoie G2, G4, G6
{my(K2,K4,K6,s,q1,q2,L1,L2,L3);

K2=2^4*3;               \\Kappa(2)
K4=2^5*3*5/11;          \\Kappa(4);
K6=2^4*3^2*7/19^2;      \\Kappa(6);

q1=exp(I*Pi*((1+sqrt(2))*Z[1]/sqrt(2)-(1-sqrt(2))*Z[2]/sqrt(2)));
q2=exp(I*Pi*(Z[2]-Z[1])/sqrt(2));


L1=vector(N);L1[1]=q1;for(i=2,N,L1[i]=L1[i-1]*q1);
L2=vector(floor((1+sqrt(2))*N)+1);L2[1]=1;for(i=2,floor((1+sqrt(2))*N+1),L2[i]=L2[i-1]*q2);
L3=vector(floor(-(1-sqrt(2))*N)+1);L3[1]=1/q2;for(i=2,floor(-(1-sqrt(2))*N)+1,L3[i]=L3[i-1]/q2);


s=sum(a=1,N,L1[a]*(sum(b=0,floor((1+sqrt(2))*a), bt2(a,b)*L2[b+1])+
                       sum(b=1,floor(-(1-sqrt(2))*a),bt2(a,-b)*L3[b])));

return([1+K2*s[1],1+K4*s[2],1+K6*s[3]]);
}


\\ Calcul invariants de Gundlach J2 J4 pour D=5
JGundlach(Z)=
{my(R,w,ww,tau,III);
w=(1+sqrt(5))/2;
ww=(1-sqrt(5))/2;
R=[1,ww;1,w];
tau=R~*[w/sqrt(5)*Z[1],0;0,-ww/sqrt(5)*Z[2]]*R;
III=EvalJinvIgusa(tau);
return(IgToGund(III));
}


\\ Calcul invariants de Gundlach J2 J4 pour D=5, avec les séries (très lent), N précision
JGundlachSer5(Z,N)=
{my(G2,G4,G6,G10,theta6,theta10);
[G2,G6,G10]=Gk(Z[1],Z[2],N);
G4=G2^2;
theta6=-67*(2^5*3^3*5^2)^(-1)*(G6-G2*G4);
theta10=(2^10*3^5*5^5*7)^(-1)*(412751*G10-5*67*2293*G4*G6+2^2*3*7*4231*G4^2*G2);

return([(G2*G4^2)/theta10,theta6*G4/theta10]);  \\J2 J4
}


\\ Calcul invariants de Gundlach J1 J3 pour D=2, L1 et L2 sont les fichiers logJ1, logJ2
JGundlachNiv2(Z,L1,L2)=
{my(R,w,ww,tau,III);
w=(1+sqrt(2));
ww=(1-sqrt(2));
R=[1,ww;1,w];
tau=R~*[w/sqrt(2)/2*Z[1],0;0,-ww/sqrt(2)/2*Z[2]]*R;
III=EvalJinvIgusa(tau);
return(IgToGundNiv2(III,L1,L2));
}


\\ Calcul invariants de Gundlach J1 J3 pour D=2 par les séries (idem, très lent)
JGundlachNiv2Ser2(Z,N)=
{my(G,H4,H6);
G=Gk2(Z,N);
H4=1/(2^6*3^2)*11*(G[1]^2-G[2]);
H6=-1/(2^8*3^3*13)*5*7^2*G[1]^3+1/(2^8*3^2*5*13)*11*59*G[1]*G[2]-1/(2^7*3^3*5*13)*19^2*G[3];

return([G[1]^2/H4,G[1]^3/H6]);
}


\\ Passage des invariants de Gundlach à ceux d'Igusa (j1,j2,j3), pour D=5 puis D=2

GundToIg(J2,J4)={my(J1);J1=J4/J2;return([8*J2*(3*J1^2*J2-2)^5,1/2*J2*(3*J1^2*J2-2)^3,2^-3*J2*(3*J1^2*J2-2)^2*(4*J1^2*J2+2^5*3^2*J1-3)]);}

GundToIgNiv2(J1,J3)={my(J2);J2=J1^2/J3;return([8*J1*J2*(1+12*J2/J1^2+12*J1/J2)^5,J2/2*(J1+144)*(1+12*J2/J1^2+12*J1/J2)^3,1/8*(1+12*J2/J1^2+12*J1/J2)^2*(J1*J2+16*J1^2+16*J2^2/J1+2304*J2^2/J1^2+408*J2+2880*J1)]);}


\\ Passage des invariants d'Igusa III=[j1,j2,j3] à ceux de Gundlach, pour D=5 puis D=2

IgToGund(III)=
{my(J1,J2);

J1=(1/6912*III[1]^2*III[2] - 1/2304*III[1]^2*III[3] - 1/3359232*III[1]*III[2]^3 + 1/373248*III[1]*III[2]^2*III[3] + 1/864*III[1]*III[2]^2 - 1/124416*III[1]*III[2]*III[3]^2 + 1/124416*III[1]*III[3]^3 + 1/3359232*III[2]^4 - 1/1119744*III[2]^3*III[3])/(III[1]*III[2]^2 + 1/1944*III[2]^4 - 1/648*III[2]^3*III[3]);

J2=-(45349632*III[1]^3*III[2]^4 - 2584929024/5*III[1]^3*III[2]^3*III[3] - 499571546112/5*III[1]^3*III[2]^3 + 11019960576/5*III[1]^3*III[2]^2*III[3]^2 +1410554953728/5*III[1]^3*III[2]^2*III[3] - 20815481088/5*III[1]^3*III[2]*III[3]^3 + 14693280768/5*III[1]^3*III[3]^4 - 186624*III[1]^2*III[2]^6 + 16236288/5*III[1]^2*III[2]^5*III[3] - 12380449536/5*III[1]^2*III[2]^5 - 23514624*III[1]^2*III[2]^4*III[3]^2 + 146887458048/5*III[1]^2*III[2]^4*III[3] + 31972578951168/5*III[1]^2*III[2]^4 + 90699264*III[1]^2*III[2]^3*III[3]^3 - 651402114048/5*III[1]^2*III[2]^3*III[3]^2 - 90275517038592/5*III[1]^2*III[2]^3*III[3] - 196515072*III[1]^2*III[2]^2*III[3]^4 + 1279948013568/5*III[1]^2*III[2]^2*III[3]^3 +226748160*III[1]^2*III[2]*III[3]^5 - 940369969152/5*III[1]^2*III[2]*III[3]^4 - 544195584/5*III[1]^2*III[3]^6 + 192*III[1]*III[2]^8 - 22464/5*III[1]*III[2]^7*III[3] - 18289152/5*III[1]*III[2]^7 + 229824/5*III[1]*III[2]^6*III[3]^2 + 260527104/5*III[1]*III[2]^6*III[3] + 30051689472/5*III[1]*III[2]^6 - 1342656/5*III[1]*III[2]^5*III[3]^3 - 1482541056/5*III[1]*III[2]^5*III[3]^2 - 171240210432/5*III[1]*III[2]^5*III[3] + 979776*III[1]*III[2]^4*III[3]^4 + 4212476928/5*III[1]*III[2]^4*III[3]^3 + 243799621632/5*III[1]*III[2]^4*III[3]^2 - 2286144*III[1]*III[2]^3*III[3]^5 - 5976073728/5*III[1]*III[2]^3*III[3]^4 + 16656192/5*III[1]*III[2]^2*III[3]^6 + 3386105856/5*III[1]*III[2]^2*III[3]^5 - 13856832/5*III[1]*III[2]*III[3]^7 + 5038848/5*III[1]*III[3]^8 - 320*III[2]^9 + 5568*III[2]^8*III[3] - 155520*III[2]^8 - 40320*III[2]^7*III[3]^2 + 4572288/5*III[2]^7*III[3] + 3869835264/5*III[2]^7 + 155520*III[2]^6*III[3]^3 - 6718464/5*III[2]^6*III[3]^2 - 336960*III[2]^5*III[3]^4 + 388800*III[2]^4*III[3]^5 - 186624*III[2]^3*III[3]^6)/(III[2]^8 - 42/5*III[2]^7*III[3] - 7776/5*III[2]^7 + 117/5*III[2]^6*III[3]^2 - 108/5*III[2]^5*III[3]^3);

return([J2,J1*J2]);
}



\\L1=read("logJ1");
\\L2=read("logJ2");

IgToGundNiv2(III,L1,L2)=
{my(j1,j2,j3,N,test,R,R1,R2,r1,r2);
j1='j1;
j2='j2;
j3='j3;
N=floor(default(realprecision,)/3);  \\ précision pour savoir quand 10^-N = 0, à arranger

test=0;
R=polroots(subst(subst(subst(L1[1],j1,III[1]),j2,III[2]),j3,III[3]));
for(k=2,47,if(test==0,R2=polroots(subst(subst(subst(L1[k],j1,III[1]),j2,III[2]),j3,III[3]));R1=R;R=[];for(i=1,length(R1),for(j=1,length(R2),if(round((R1[i]-R2[j])*10^N)==0,R=concat(R,[R1[i]]))));if(length(R)==1,test=1)));

if(test==1,r1=R[1],print("erreur1 sur les racines communes"));

test=0;
R=polroots(subst(subst(subst(L2[1],j1,III[1]),j2,III[2]),j3,III[3]));
for(k=2,53,if(test==0,R2=polroots(subst(subst(subst(L2[k],j1,III[1]),j2,III[2]),j3,III[3]));R1=R;R=[];for(i=1,length(R1),for(j=1,length(R2),if(round((R1[i]-R2[j])*10^N)==0,R=concat(R,[R1[i]]))));if(length(R)==1,test=1)));

if(test==1,r2=R[1],print("erreur2 sur les racines communes"));

return([r1,r1^2/r2]);
}




/*******************************************************************************************************/

\\ Passage des invariants d'Igusa III=[j1,j2,j3] à Omega dans le domaine fondamental de l'espace de Siegel tel que j_i(Omega)=j_i

OmegaFromIg(III)=
{my(JJJ,P,E,Bj2,tau,III2,realprec);

III2=[III[2]/III[1]*(III[2]-3*III[3])/2,III[2]^2/III[1],III[2]^5/III[1]^3];  \\ de Igusa à Streng
JJJ=invariants_streng_to_igusaclebsch(III2);

P=curve_from_igusaclebsch_on_C(JJJ);
E=polroots(P);

Bj2=EvalBjFromCurveEq(E,default(realprecision,));
tau=EvalTauFrombj(Bj2);
tau=ReduceToF2(tau)[2];
return(tau);
}



/*********/

\\ Passage de Z=[z1,z2] dans espace de Hilbert à Omega dans espace de Siegel

TauToOmegaNiv5(Z)=
{my(R,w,ww);
w=(1+sqrt(5))/2;
ww=(1-sqrt(5))/2;
R=[1,ww;1,w];

return((R~)*[w/sqrt(5)*Z[1],0;0,-ww/sqrt(5)*Z[2]]*R);
}


\\ Passage de Omega dans espace de Siegel à Z=[z1,z2] dans espace de Hilbert

OmegaToTauNiv5(Omega)=
{my(R,Tau,z1,z2);
Omega=Mtau(Inverser(Omega,5),Omega);  \\ on cherche un bon représentant pour la classe d'équivalence de Omega: un tel que Omega=phi(Z)

R=[1,(1-sqrt(5))/2;1,(1+sqrt(5))/2];
Tau=(R~)^-1*Omega*R^-1;
z1=Tau[1,1]*sqrt(5)/(1+sqrt(5))*2;
z2=-Tau[2,2]*sqrt(5)/(1-sqrt(5))*2;

return([z1,z2]);
}

\\ Passage de J2,J4 à Z tel que J_i(Z)=J_i

taufromgundNiv5(J2,J4)=
{my(III,Omega,Tau,R,z1,z2,A,B);
III=GundToIg(J2,J4);
Omega=OmegaFromIg(III);
Omega=Mtau(Inverser(Omega,5),Omega);

R=[1,(1-sqrt(5))/2;1,(1+sqrt(5))/2];
Tau=(R~)^-1*Omega*R^-1;
z1=Tau[1,1]*sqrt(5)/(1+sqrt(5))*2;
z2=-Tau[2,2]*sqrt(5)/(1-sqrt(5))*2;

\\ vérification
if(abs(Tau[2,1])>10^-60||abs(Tau[1,2])>10^-60,print("erreur1"));
[A,B]=JGundlach([z1,z2]);
if(abs(A-J2)>10^-30||abs(B-J4)>10^-30,print("erreur2"));

return([z1,z2]);
}



\\ Passage de bp1,bp2 (fct theta) à Z. Renvoie les 5 Z_i qui ont pour image bp1,bp2
\\M=read("classeSLTh");
\\MM=read("actionG24");

taufromthetNiv5(bp1,bp2,M,MM)=  
{my(P,x,bp3,Omega,gam,Omega2,R,Tau,z1,z2,Z,test,test2,Tab,Tab2);
x='x;
(P(x,y,z)=-1/2*(x^4+y^4+z^4+x^4*y^4+x^4*z^4+y^4*z^4)+x*y*z+x^5*y*z+x*y^5*z+x*y*z^5-x^2*y^2*z^2);

bp3=polroots(P(bp1,bp2,x));  \\ 5 valeurs possibles pour bp3, une fois bp1 et bp2 fixés

Omega=vector(5,i,TauFromBjp(bp1,bp2,bp3[i],MM));
gam=vector(5,i,Inverser(Omega[i],5));
Omega2=vector(5,i,Mtau(gam[i],Omega[i]));

R=[1,(1-sqrt(5))/2;1,(1+sqrt(5))/2];
Tau=vector(5,i,(R~)^-1*Omega2[i]*R^-1);
z1=vector(5,i,Tau[i][1,1]*sqrt(5)/(1+sqrt(5))*2);
z2=vector(5,i,-Tau[i][2,2]*sqrt(5)/(1-sqrt(5))*2);


Tab=[1, 11, 2, 12, 81, 32, 82, 19, 20, 35, 10, 472, 203, 473, 211, 212, 206, 78, 132, 53, 133, 56, 18, 228, 229, 28, 79, 332, 105, 1077, 1078, 1050, 14, 1116, 504, 1117, 507, 210, 1092, 1093, 196, 15, 324, 730, 333, 327, 129, 349, 350, 49, 130, 1198, 545, 1199, 548, 227, 188, 189, 199, 1617, 1618, 260, 88, 3625, 2216, 3558, 2219, 1076, 4096, 4097, 39, 89, 2287, 4271, 156, 2290, 1113, 2302, 2303, 417, 1114, 3116, 2248, 4220, 2251, 1091, 1040, 1041, 42, 1578, 1579, 1552, 22, 763, 331, 1593, 1594, 317, 23, 1692, 799, 1693, 802, 348, 309, 310, 320, 2431, 4505, 2439, 2434, 1195, 2453, 2454, 541, 1196, 1008, 453, 1009, 456, 187, 1056, 1057, 3110, 3179, 5616, 3182, 1614, 1327, 1328, 220, 489, 2788, 3623, 1132, 1839, 2903, 6964, 6965, 1518, 2904, 3019, 6860, 3020, 6862, 715, 251, 252, 222, 2491, 6825, 214, 380, 139, 7092, 7093, 1015, 215, 7125, 4306, 7126, 4309, 2301, 311, 312, 2285, 1582, 4983, 1216, 7013, 4217, 7022, 7023, 2244, 4218, 3009, 2148, 3010, 2151, 712, 266, 267, 2716, 3113, 1577, 5459, 5460, 60, 140, 3193, 3194, 678, 1615, 2223, 3141, 5570, 3144, 1592, 1157, 1547, 63, 3306, 5799, 3314, 3309, 1689, 3325, 3326, 795, 1690, 1519, 308, 1558, 1559, 2787, 6888, 231, 3593, 2438, 7419, 7420, 2425, 232, 7449, 4547, 7450, 3566, 2452, 622, 2428, 2093, 2089, 2103, 2104, 679, 3472, 2180, 4116, 2182, 1055, 1630, 3360, 7187, 335, 8601, 8602, 1524, 336, 3023, 2669, 3024, 2672, 717, 1158, 1159, 1086, 2786, 2619, 1080, 2315, 1121, 3259, 6150, 2611, 1081, 343, 5552, 5751, 8820, 1664, 1951, 2106, 1973, 7923, 4230, 5405, 2729, 11250, 8828, 3017, 1295, 593, 913, 596, 250, 1167, 1168, 3481, 2490, 10821, 11236, 510, 1122, 1810, 1811, 341, 746, 3188, 9895, 10199, 9896, 7091, 3137, 513, 5622, 11331, 9924, 8810, 7122, 7899, 2712, 1655, 7123, 642, 5645, 7079, 2736, 1095, 2463, 1205, 9633, 9155, 2723, 1096, 7835, 7967, 10923, 9842, 7021, 418, 7011, 872, 3196, 6826, 6827, 2613, 1356, 626, 1357, 629, 265, 1972, 6989, 8508, 6966, 2107, 7455, 371, 372, 7086, 7294, 5648, 2367, 190, 191, 3177, 6180, 1709, 7953, 4811, 8553, 8554, 5568, 2094, 2095, 2324, 386, 387, 3624, 7322, 352, 2755, 3313, 8807, 8808, 2633, 353, 5833, 8829, 2726, 3324, 3303, 3005, 3076, 5475, 3078, 1557, 11262, 8736, 551, 1206, 9170, 3589, 2725, 5014, 6864, 10151, 9965, 10152, 7418, 7398, 554, 9032, 4350, 10170, 7447, 1561, 4543, 3319, 7406, 7407, 3984, 6727, 6728, 2615, 1845, 5462, 3999, 1454, 3484, 6880, 6889, 3262, 3203, 1621, 2632, 3359, 9904, 11353, 765, 1622, 2296, 10814, 10946, 10815, 7110, 768, 7430, 7834, 5411, 2441, 7839, 7840, 2442, 3465, 2362, 4371, 2364, 4201, 4202, 1581, 876, 5830, 1782, 5675, 7164, 1293, 4279, 1661, 1854, 8552, 389, 7746, 1662, 6730, 8738, 4010, 7457, 2455, 3265, 5747, 3513, 6747, 7320, 3468, 2750, 4224, 5301, 10636, 1363, 4099, 2447, 11376, 10922, 7754, 7436, 5401, 2612, 1813, 2620, 2621, 805, 2380, 3756, 2383, 939, 9043, 8614, 6829, 11309, 370, 632, 2113, 2114, 3516, 458, 1043, 1044, 1587, 6187, 7140, 11089, 10042, 9434, 8555, 11065, 2321, 2322, 11296, 2305, 7333, 9923, 9512, 7291, 2306, 8845, 7897, 1354, 7898, 7945, 10828, 9880, 6823, 7939, 5677, 577, 4225, 7467, 7468, 1353, 4515, 2676, 10961, 8561, 9433, 7845, 7917, 2256, 4890, 9128, 11307, 7081, 4946, 9927, 11068, 11098, 385, 8628, 8629, 3208, 7193, 11238, 7928, 4797, 2724, 2719, 2737, 2738, 4446, 1170, 5580, 4004, 11388, 844, 663, 847, 11326, 7422, 9120, 3554, 1161, 7292, 892, 8594, 3575, 1596, 3335, 1698, 10679, 7950, 1597, 9072, 7910, 10789, 8544, 7194, 1840, 879, 11372, 1699, 7968, 2751, 3565, 6209, 8435, 9511, 8806, 7782, 808, 5679, 10929, 7437, 1059, 8797, 7317, 6883, 6884, 2636, 8447, 7323, 11251, 5856, 375, 7909, 9167, 6205, 6994, 2754, 11063, 7167, 10068, 11488, 10982, 7031, 2468, 2469, 8381, 2325, 9995, 11473, 7329, 2456, 3081, 10142, 11022, 6050, 9615, 9616, 600, 7753, 5555, 1299, 6159, 7408, 5195, 5196, 6065, 10617, 11086, 7481, 8737, 4343, 8645, 1780, 7780, 7108, 7198, 11489, 882, 4990, 8637, 10530, 9674, 10598, 7024, 6737, 10456, 3209, 3210, 7930, 1330, 7328, 7833, 10374, 4439, 1331, 7019, 9165, 10997, 8662, 7838, 2739, 828, 7166, 7283, 7284, 8371, 6991, 2623, 2153, 2386, 6837, 9119, 2155, 254, 255, 5198, 3584, 10230, 1846, 2110, 5860, 8453, 7454, 3754, 7755, 4571, 1785, 7960, 7961, 3753, 8510, 3328, 5299, 8556, 2471, 4955, 10824, 8835, 6752, 3327, 8798, 2320, 6102, 7761, 4813, 1372, 6425, 7321, 850, 9617, 8854, 11076, 269, 6761, 4017, 9076, 9077, 2111, 4071, 5553, 3577, 8457, 7131, 4579, 10632, 10546, 7188, 4346, 10652, 7132, 11061, 9986, 8596, 3197, 3874, 9156, 11005, 270, 10871, 6063, 8747, 10944, 7843, 2740, 6895, 6896, 2185, 7332, 6184, 11425, 10495, 8559, 7028, 7029, 6968, 10447, 11297, 7025, 8847, 7931, 2731, 1836, 1837, 8661, 11327, 3466, 11354, 11011, 10358, 10359, 2467, 3590, 4987, 7941, 7324, 4440, 3588, 5574, 3876, 9530, 11494, 3473, 11484, 10628, 9118, 9151, 10345, 9145, 5575, 8844, 5808, 3520, 10231, 10458, 7032, 3149, 10470, 9137, 3561, 3576, 11472, 7963, 5009, 7964, 3592, 10453, 8647, 10278, 10279, 3340, 3341, 3212, 10853, 11253, 8743, 10259, 10369, 4204, 4836, 9487, 10521, 8856, 11058, 8294, 9164, 9147, 11434, 9565, 11312, 7479, 3579, 9626, 9994, 11375, 8454, 8616, 10832, 2634, 1665, 9632, 2389, 9983, 9678, 7286, 374, 9075, 10360, 6834, 5863, 9522, 8664, 9846, 10616, 9931, 4576, 885, 9930, 7944, 10044, 11295, 3339, 10337, 8550, 6835, 8167, 3570, 1814, 3343, 7477, 1171, 8742, 635, 7482, 6892, 8833, 8456, 7184, 7185, 10368, 2746, 3482, 8852, 1364, 9139, 10322, 3578, 8528, 9408, 11334, 2472, 9140, 7470, 9486, 8744, 6003, 10450, 8857, 10584, 6893, 9564, 7927, 390, 7111, 5300, 9910, 7951, 10033, 4834, 10196, 8746, 10344, 2752, 6604, 10852, 11493, 3268, 9485, 9528, 9136, 9150, 9676, 11483, 6002, 10833, 7330, 3344, 3875, 4746, 4747];

Tab2=[410, 1926, 290, 409, 6349, 1191, 1925, 1444, 289, 185, 1928, 8623, 4216, 6348, 4494, 1190, 1075, 6350, 5171, 1685, 1443, 306, 1446, 996, 184, 1112, 1927, 5791, 1922, 9826, 4215, 4094, 1924, 10132, 7118, 4493, 1943, 4496, 4170, 1074, 4114, 408, 5567, 5170, 1684, 1576, 5172, 1508, 305, 1613, 1445, 3936, 2068, 995, 445, 1001, 4268, 1111, 1039, 10917, 5790, 1325, 6347, 5060, 10898, 4243, 5242, 4245, 9693, 4093, 1347, 1923, 11075, 10131, 1440, 7083, 8119, 6397, 1942, 6514, 4495, 4727, 6556, 4169, 2212, 4176, 5767, 4113, 249, 10774, 5566, 5457, 1442, 2876, 5793, 5523, 1575, 5474, 288, 5356, 2990, 1507, 705, 1513, 5614, 1612, 1546, 6131, 3935, 4879, 2065, 3947, 2020, 2071, 2075, 1000, 5150, 6745, 4267, 2087, 4269, 4065, 1038, 10090, 10493, 9702, 8598, 9274, 4882, 1324, 4436, 6346, 6249, 5059, 4490, 6020, 9859, 10600, 5241, 6330, 4244, 3792, 10327, 3001, 6856, 3003, 4934, 1346, 1156, 6130, 11178, 4492, 1808, 5169, 9578, 7082, 5148, 1189, 11126, 9344, 6396, 3734, 6399, 1915, 1611, 6432, 5565, 4726, 991, 6953, 6627, 6923, 6960, 6328, 4175, 10118, 8361, 5766, 6782, 8379, 1286, 248, 5592, 3804, 5594, 10697, 5456, 1830, 1441, 8145, 2875, 8237, 5792, 5983, 8261, 5522, 3106, 5529, 4467, 5473, 369, 4924, 5355, 4759, 2987, 5366, 2943, 2992, 2996, 1512, 5613, 5615, 5443, 1545, 6247, 6675, 993, 3440, 6695, 6687, 6689, 6692, 183, 6509, 3867, 6595, 3953, 2070, 1913, 2073, 6744, 5496, 6725, 2086, 2916, 3897, 6818, 4064, 2145, 3686, 5787, 4923, 11254, 5789, 10659, 8597, 6329, 1683, 4618, 7827, 1236, 2665, 1238, 5780, 4435, 4199, 6248, 5319, 4925, 7162, 8033, 8721, 6019, 10116, 4214, 1653, 10760, 5725, 8229, 5727, 6703, 5230, 5593, 3791, 1268, 5380, 7721, 11198, 8234, 3002, 5069, 7759, 1400, 1492, 1402, 4406, 1155, 4608, 11041, 11501, 11177, 7179, 4491, 6095, 1807, 5744, 5168, 8613, 11222, 9577, 9235, 11322, 5147, 2312, 10058, 11125, 10037, 8354, 11127, 7620, 2605, 5743, 6398, 1914, 10552, 6431, 2602, 1270, 2056, 3931, 8884, 8991, 3892, 1073, 7825, 7683, 10669, 9784, 6959, 1986, 6962, 1431, 7502, 11232, 6781, 7758, 4771, 2598, 1285, 588, 1292, 10800, 9438, 3803, 11000, 2085, 6510, 6141, 1829, 11325, 7287, 5179, 7289, 1433, 1110, 8172, 5982, 1503, 7717, 8128, 8482, 8504, 5528, 10097, 4466, 7152, 1773, 368, 5058, 7280, 1505, 2584, 8023, 8353, 8355, 7773, 304, 5292, 8287, 4068, 2991, 2994, 4139, 8416, 5442, 3050, 2851, 11224, 8212, 1883, 992, 8990, 3424, 7740, 4616, 6853, 8273, 9956, 9593, 6625, 4606, 441, 4391, 4319, 9518, 6594, 1544, 3896, 2981, 6597, 6699, 7144, 10716, 5495, 5715, 6013, 5455, 3975, 1470, 3474, 6816, 6797, 3244, 8643, 9214, 5885, 10414, 11422, 11344, 8656, 5788, 7105, 11469, 10658, 8063, 11140, 3200, 4617, 4390, 2498, 4620, 7811, 7831, 1237, 10095, 8676, 4465, 6385, 9808, 4198, 6132, 3454, 5318, 6257, 10837, 7161, 5071, 10130, 5729, 1768, 8503, 1770, 10115, 1652, 5494, 8352, 8087, 6463, 1984, 5068, 5726, 9067, 5229, 6484, 4392, 2559, 4722, 5182, 10553, 4764, 4092, 2059, 11223, 6575, 5714, 6501, 5383, 4481, 2795, 5314, 1491, 1401, 7276, 953, 2359, 955, 4607, 11017, 6780, 11271, 1884, 2591, 5894, 1728, 3509, 1730, 4483, 4112, 5550, 6035, 6392, 7461, 11383, 9418, 8466, 11016, 7155, 2311, 11294, 6394, 7270, 10297, 8839, 11366, 1941, 8316, 7619, 1291, 7745, 7540, 10874, 9374, 7374, 7617, 5656, 2565, 1269, 6634, 6635, 4781, 3930, 2661, 10952, 8499, 9417, 7719, 3891, 2209, 4880, 8982, 11277, 6430, 4770, 9338, 11003, 7889, 1779, 11395, 7501, 6537, 11343, 11176, 7727, 6358, 978, 2595, 2538, 2603, 4402, 4404, 1755, 3972, 11153, 9035, 1882, 980, 11324, 6688, 8952, 3460, 4434, 7288, 1432, 8171, 3457, 1757, 2978, 5352, 7521, 7686, 1574, 9065, 7735, 10746, 8506, 7151, 1772, 839, 11144, 1504, 7684, 2566, 8072, 5892, 8428, 9354, 8308, 5883, 701, 5653, 10631, 6674, 1037, 8288, 7272, 9734, 4138, 2625, 8415, 7245, 11216, 5321, 1828, 7674, 8463, 5986, 6983, 2583, 10984, 7160, 6645, 11479, 6646, 6951, 2038, 2039, 3790, 2310, 6486, 11471, 7258, 2021, 3047, 9520, 6547, 2035, 10504, 7143, 2627, 10866, 5548, 4932, 6012, 6598, 5244, 1469, 6051, 10610, 8011, 6632, 8695, 9952, 8642, 6259, 5884, 10357, 7150, 11476, 3447, 4790, 7500, 8838, 11379, 10588, 6907, 10094, 10356, 8639, 3199, 7531, 3632, 7254, 10027, 7520, 7535, 1323, 2562, 7699, 10936, 6536, 7518, 2502, 3423, 7349, 11118, 6384, 4137, 6986, 1490, 7217, 6256, 6830, 9028, 6832, 4933, 1345, 1468, 3441, 10209, 1769, 5896, 5240, 8404, 6462, 954, 5713, 3899, 6139, 7658, 7659, 3806, 4721, 2944, 5176, 8483, 2053, 4763, 8010, 6574, 5228, 2914, 8289, 7158, 6093, 5313, 2957, 1281, 1980, 7244, 3476, 7142, 8305, 8062, 1283, 5893, 3366, 9060, 9070, 1729, 4482, 5549, 3458, 8412, 11123, 3926, 6487, 9110, 7154, 4323, 7597, 6393, 11013, 9320, 8170, 2874, 3730, 8992, 7573, 247, 10864, 6054, 8716, 10646, 7817, 2539, 6481, 6813, 2142, 6672, 5948, 11284, 9234, 8490, 6938, 6939, 5977, 9003, 11291, 6924, 8340, 7725, 2588, 6029, 1778, 11179, 11323, 5779, 11342, 7888, 10513, 6357, 2032, 3425, 4681, 7618, 6686, 4403, 3417, 5978, 3738, 9346, 11470, 979, 11482, 7462, 8951, 8896, 10304, 8949, 1756, 8315, 5351, 3505, 10213, 10334, 6952, 3103, 10332, 9016, 3451, 3402, 11468, 6904, 4730, 7671, 3439, 10289, 8641, 8323, 8324, 2960, 2961, 3198, 8214, 11248, 8705, 10247, 8254, 4197, 4819, 9477, 9199, 8313, 7700, 8147, 8971, 8950, 11267, 8937, 11283, 6621, 3403, 6546, 9936, 11263, 8405, 8612, 9938, 2626, 1651, 8883, 2355, 9949, 9667, 6383, 6140, 8881, 6356, 11241, 5347, 8215, 6535, 7596, 10609, 7572, 3802, 835, 9302, 7499, 9329, 11288, 2954, 8920, 3420, 6831, 2910, 3444, 1806, 2975, 6613, 1154, 8701, 584, 6633, 6803, 8195, 8209, 11346, 7157, 8253, 2585, 3475, 8297, 1282, 8890, 10183, 3370, 8524, 9377, 11122, 2054, 9014, 6670, 9476, 8706, 5960, 10351, 8314, 10566, 6804, 8936, 7724, 367, 7104, 5181, 9198, 7687, 10025, 4822, 9553, 8342, 9109, 2567, 6401, 9300, 11475, 3240, 9471, 9326, 9013, 8871, 9670, 11481, 5959, 8919, 7259, 2976, 3737, 4703, 4704];


Z=[];
for(k=1,5,
   test=0;for(i=1,11520,if(test==0&&dansG24(MM[i][1]*gam[k]),test=i));
   if(test==0,print("erreur anormale: gam n'est pas dans Gamma_2 ??"));

   test2=0;
   for(i=1,length(Tab),if(Tab[i]==test,test=i;test2=1;break));

   if(test2,Z=concat(Z,[mtau5(M[test],[z1[k],z2[k]])]),
      for(i=1,length(Tab),if(Tab2[i]==test,test=i;test2=1;break));
      if(test2==0,print("problème: il manque une classe ??"));
      Z=concat(Z,[mtau5(M[test],[z2[k],z1[k]])])));

return(Z);
}

\\ Action matrice M sur Z=[z1,z2]

mtau5(M,Z)=
{my(a,b,c,d,aa,bb,cc,dd,w,ww,x);
x='x;
w=(1+sqrt(5))/2;
ww=(1-sqrt(5))/2;
[a,b,c,d]=[subst(lift(M[1,1]),x,w),subst(lift(M[1,2]),x,w),subst(lift(M[2,1]),x,w),subst(lift(M[2,2]),x,w)];
[aa,bb,cc,dd]=[subst(lift(M[1,1]),x,ww),subst(lift(M[1,2]),x,ww),subst(lift(M[2,1]),x,ww),subst(lift(M[2,2]),x,ww)];
return([(a*Z[1]+b)/(c*Z[1]+d),(aa*Z[2]+bb)/(cc*Z[2]+dd)]);
}

\\ Image d'une matrice M dz SL_2(OK) dans Gamma_2 (matrice symplectique)

PhiGam5(M)=
{my(R,S,x);
x='x;
R=[1,(1-sqrt(5))/2;1,(1+sqrt(5))/2];
S=matconcat([R~,0;0,R^-1])*matconcat([matid(2),0;0,[2*sqrt(5)/(1+sqrt(5)),0;0,-2*sqrt(5)/(1-sqrt(5))]]);
return(round(subst(lift( S*matconcat([[M[1,1],0;0,conj(M[1,1])],[M[1,2],0;0,conj(M[1,2])];[M[2,1],0;0,conj(M[2,1])],[M[2,2],0;0,conj(M[2,2])]])*S^-1),x,(1+sqrt(5))/2)));
}



/*********/



TauToOmegaNiv2(Z)=
{my(R,w,ww);
w=1+sqrt(2);
ww=1-sqrt(2);

R=[1,ww;1,w];
return((R~)*[w/sqrt(2)/2*Z[1],0;0,-ww/sqrt(2)/2*Z[2]]*R);
}


OmegaToTauNiv2(Omega)=
{my(R,Tau,z1,z2);

Omega=Mtau(Inverser(Omega,8),Omega);
R=[1,1-sqrt(2);1,1+sqrt(2)];
Tau=(R~)^-1*Omega*R^-1;
z1=Tau[1,1]*2*sqrt(2)/(1+sqrt(2));
z2=-Tau[2,2]*2*sqrt(2)/(1-sqrt(2));

return([z1,z2]);
}



taufromgundNiv2(J1,J3)=
{my(III,Omega,Tau,R,z1,z2);


III=GundToIgNiv2(J1,J3);
Omega=OmegaFromIg(III);
Omega=Mtau(Inverser(Omega,8),Omega);

R=[1,1-sqrt(2);1,1+sqrt(2)];
Tau=(R~)^-1*Omega*R^-1;
z1=Tau[1,1]*2*sqrt(2)/(1+sqrt(2));
z2=-Tau[2,2]*2*sqrt(2)/(1-sqrt(2));

if(abs(Tau[2,1])>10^-30||abs(Tau[1,2])>10^-30,print("erreur1"));
\\[A,B]=JGundlachNiv2([z1,z2]);
\\if(abs(B-J3)>10^-30||abs(A*B-J4)>10^-30,print("erreur2"));

return([z1,z2]);
}


\\M=read("classeSLThNiv2");
\\MM=read("actionG24");

taufromthetNiv2(bp1,bp2,M,MM)=  
{my(bp3,Omega,Omega2,R,Tau,z1,z2,gam,Z,test,Tab);

bp3=1/2*(bp1^2+bp2^2); \\ ici, bp3 est déterminé par bp1, bp2

Omega=TauFromBjp(bp1,bp2,bp3,MM);
gam=Inverser(Omega,8);
Omega2=Mtau(gam,Omega);

R=[1,1-sqrt(2);1,1+sqrt(2)];
Tau=(R~)^-1*Omega2*R^-1;
z1=Tau[1,1]*2*sqrt(2)/(1+sqrt(2));
z2=-Tau[2,2]*2*sqrt(2)/(1-sqrt(2));
Z=[z1,z2];


test=0;for(i=1,11520,if(test==0&&dansG24(MM[i][1]*gam),test=i));
if(test==0,print("erreur anormale: gam n'est pas dans Gamma_2 ??"));


Tab=[1, 11, 2, 221, 81, 32, 31, 19, 342, 527, 472, 203, 198, 211, 2295, 83, 132, 53, 52, 781, 2372, 2774, 332, 41, 1077, 5806, 474, 1116, 504, 503, 4291, 496, 3491, 324, 319, 3187, 134, 3251, 3611, 6419, 4426, 3751, 3652, 1617, 760, 106, 3625, 2216, 2122, 8162, 2170, 7854, 2287, 2284, 62, 1118, 5100, 5416, 1795, 1104, 1103, 6070, 1578, 4513, 731, 4420, 753, 2644, 4023, 5193, 2815, 7049, 1343, 2418, 5471, 3110, 3179, 3176, 1619, 614, 4913, 2788, 5226, 512, 1027, 1605, 8574, 6476, 4105, 4104, 9082, 3115, 4272, 157, 4286, 7300, 6234, 3249, 3028, 4238, 4432, 2265, 3055, 3031, 3066, 6284, 4025, 1311, 1604, 4846, 1826, 3295, 4110, 2695, 7391, 4494, 3292, 767, 2222, 4083, 5629, 7036, 1535, 1335, 720, 7856, 3786, 8205, 1133, 2119, 5741, 853, 6869, 5467, 5043, 864, 6121, 7099, 5587, 7177, 2866, 7309, 7044, 9826, 2870, 4841, 2370, 3157, 2158, 3538, 5791, 2415, 7872, 10493, 10132, 7118, 10090, 1631, 6842, 8607, 673, 8654, 1818, 4332, 7387, 670, 10917, 461, 9095, 603, 8570, 290, 1685, 5060, 10898, 5171, 3700, 10774, 3704, 11075, 8623, 4216, 5664, 1444, 1191, 923, 5567, 920, 6249, 410, 6349, 1926];

for(i=1,length(Tab),if(Tab[i]==test,test=i;break));

return(mtau2(M[test],Z));
}



mtau2(M,Z)=
{my(a,b,c,d,aa,bb,cc,dd,w,ww,x);
x='x;
w=sqrt(2);
ww=-sqrt(2);
[a,b,c,d]=[subst(lift(M[1,1]),x,w),subst(lift(M[1,2]),x,w),subst(lift(M[2,1]),x,w),subst(lift(M[2,2]),x,w)];
[aa,bb,cc,dd]=[subst(lift(M[1,1]),x,ww),subst(lift(M[1,2]),x,ww),subst(lift(M[2,1]),x,ww),subst(lift(M[2,2]),x,ww)];
return([(a*Z[1]+b)/(c*Z[1]+d),(aa*Z[2]+bb)/(cc*Z[2]+dd)]);
}


PhiGam2(M)=
{my(R,S,x);
x='x;
R=[1,(1-sqrt(2));1,(1+sqrt(2))];
S=matconcat([R~,0;0,R^-1])*matconcat([matid(2),0;0,[2*sqrt(2)/(1+sqrt(2)),0;0,-2*sqrt(2)/(1-sqrt(2))]]);
return(round(subst(lift(S*matconcat([[M[1,1],0;0,conj(M[1,1])],[M[1,2],0;0,conj(M[1,2])];[M[2,1],0;0,conj(M[2,1])],[M[2,2],0;0,conj(M[2,2])]])*S^-1),x,sqrt(2))));
}


/*********/


TauToOmegaNiv3(Z)=
{my(R,w,ww);
w=sqrt(3);
ww=-sqrt(3);

R=[1,ww;1,w];
return((R~)*[Z[1],0;0,Z[2]]*R);
}


OmegaToTauNiv3(Omega)=
{my(R,Tau,z1,z2);

Omega=Mtau(Inverser2(Omega,12),Omega);
R=[1,-sqrt(3);1,sqrt(3)];
Tau=(R~)^-1*Omega*R^-1;
z1=Tau[1,1];
z2=Tau[2,2];

return([z1,z2]);
}



\\M=read("classeSLThNiv3"); classeSLDG24-3 
\\MM=read("actionG24");

taufromthetNiv3(bp1,bp2,M,MM)=  
{my(P,bp3,Omega,gam,Omega2,R,Tau,z1,z2,Z,test,Tab,x);
x='x;
(P(x,y,z)=-x^4 - 2*x^2*y^2 + (4*z^2 + 4)*x*y + (-y^4 - 4*z^2));

bp3=polroots(P(bp1,bp2,x));  \\ 2 solutions pour bp3

Omega=vector(2,i,TauFromBjp(bp1,bp2,bp3[i],MM));
gam=vector(2,i,Inverser2(Omega[i],12));
Omega2=vector(2,i,Mtau(gam[i],Omega[i]));

R=[1,-sqrt(3);1,sqrt(3)];
Tau=vector(2,i,(R~)^-1*Omega2[i]*R^-1);
z1=vector(2,i,Tau[i][1,1]);
z2=vector(2,i,Tau[i][2,2]);

Tab=[1, 88, 5, 290, 81, 221, 4436, 66, 5172, 117, 78, 205, 4216, 2370, 10097, 2377, 1895, 24, 5171, 2870, 317, 198, 4114, 2226, 9859, 2241, 7100, 1162, 10095, 7351, 3359, 1880, 904, 1389, 5169, 2868, 324, 731, 3465, 728, 2158, 5744, 2175, 6731, 1082, 5060, 7044, 2611, 7099, 4286, 6057, 5474, 7350, 1972, 5628, 3625, 5806, 1873, 897, 1396, 2777, 6419, 2774, 2866, 341, 747, 2490, 744, 6116, 1555, 2094, 6039, 10800, 3614, 1045, 10118, 3256, 139, 1590, 3980, 4908, 10414, 2791, 2788, 8205, 3009, 4796, 3653, 4285, 4513, 8574, 1583, 9042, 3071, 129, 4335, 3786, 5100, 8607, 2903, 1878, 6249, 894, 1412, 8654, 5043, 4248, 9360, 9095, 781, 196, 780, 4825, 9082, 8372, 220, 3986, 9419, 8570, 7177, 6234, 654, 10116, 7375, 1656, 132, 342, 7778, 8651, 6476, 7854, 7872, 1894, 10114, 5391, 11041, 6284, 644, 1659, 5597, 5387, 3119, 3134, 1548, 2, 319, 4332, 2816, 2815, 203, 5226, 1398, 3628, 474, 5667, 527, 7049, 1871, 470, 6350, 8608, 1089, 526, 6347, 10096, 7172, 3611, 647, 1413, 7372, 5629, 3249, 326, 5567, 3055, 5664, 8162, 3652, 1391, 16, 490, 8, 410, 1053, 487, 6349, 3704, 1165, 3700, 45, 168, 3702];

Z=[];
for(k=1,2,
  test=0;for(i=1,11520,if(test==0&&dansG24(MM[i][1]*gam[k]),test=i));
  if(test==0,print("erreur anormale: gam n'est pas dans Gamma_2 ??"));
  for(i=1,length(Tab),if(Tab[i]==test,Z=concat(Z,[mtau3(M[i],[z1[k],z2[k]])]))));

return(Z);

}



mtau3(M,Z)=
{my(a,b,c,d,aa,bb,cc,dd,w,ww,x);
x='x;
w=sqrt(3);
ww=-sqrt(3);
[a,b,c,d]=[subst(lift(M[1,1]),x,w),subst(lift(M[1,2]),x,w),subst(lift(M[2,1]),x,w),subst(lift(M[2,2]),x,w)];
[aa,bb,cc,dd]=[subst(lift(M[1,1]),x,ww),subst(lift(M[1,2]),x,ww),subst(lift(M[2,1]),x,ww),subst(lift(M[2,2]),x,ww)];
return([(a*Z[1]+b)/(c*Z[1]+d),(aa*Z[2]+bb)/(cc*Z[2]+dd)]);
}


PhiGam3(M)=
{my(R,S,x);
x='x;
R=[1,Mod(-x,x^2-3);1,Mod(x,x^2-3)];
S=matconcat([R~,0;0,R^-1]);
return(subst(lift(S*matconcat([[M[1,1],0;0,conj(M[1,1])],[M[1,2],0;0,conj(M[1,2])];[M[2,1],0;0,conj(M[2,1])],[M[2,2],0;0,conj(M[2,2])]])*S^-1),x,sqrt(3)));
}


/*********/

\\ Même fonctions que plus haut, mais pour tout D

TauToOmega(Z,D)=
{my(R,w,ww);
if(D%4==1,w=(1+sqrt(D))/2;ww=(1-sqrt(D))/2,w=sqrt(D);ww=-w);
R=[1,w;1,ww];
return((R~)*[Z[1],0;0,Z[2]]*R);
}


OmegaToTau(Omega,D)=
{my(R,Tau,z1,z2,disc,w,ww);
if(D%4==1,disc=D,disc=4*D);
if(D%4==1,w=(1+sqrt(D))/2;ww=(1-sqrt(D))/2,w=sqrt(D);ww=-w);

Omega=Mtau(Inverser2(Omega,disc),Omega);

R=[1,w;1,ww];
Tau=(R~)^-1*Omega*R^-1;
z1=Tau[1,1];
z2=Tau[2,2];

return([z1,z2]);
}


\\ seulement pour D=2,3,5
taufromthetNivD(bp1,bp2,M,MM,D)=  
{my(P,bp3,Omega,gam,Omega2,R,Tau,z1,z2,Z,test,test2,Tab,TabM,Tab2,Tab3,Tab5,Tab5M,dsc,w,ww,nb,x);
x='x;

\\P6(b1,b2,b3)=256*b3^2*b2^2*b1^8 + (-128*b2^2 - 128*b3^2)*b1^7 + (-128*b2^4 + (-128*b3^4 + 64))*b1^6 + (-32*b2^6 - 352*b3^2*b2^4 + (-352*b3^4 + 64)*b2^2 + (-32*b3^6 + 64*b3^2))*b1^5 + (-192*b3^2*b2^6 + (640*b3^4 + 240)*b2^4 + (-192*b3^6 + 480*b3^2)*b2^2 + 240*b3^4)*b1^4 + (288*b2^6 - 160*b3^2*b2^4 + (-160*b3^4 - 128)*b2^2 + (288*b3^6 - 128*b3^2))*b1^3 + (124*b2^8 - 400*b3^2*b2^6 + (1000*b3^4 - 128)*b2^4 - 400*b3^6*b2^2 + (124*b3^8 - 128*b3^4))*b1^2 + (20*b2^10 - 28*b3^2*b2^8 + (-184*b3^4 - 32)*b2^6 + (-184*b3^6 - 352*b3^2)*b2^4 + (-28*b3^8 - 352*b3^4)*b2^2 + (20*b3^10 - 32*b3^6))*b1 + (b2^12 + 6*b3^2*b2^10 + 15*b3^4*b2^8 + (20*b3^6 - 192*b3^2)*b2^6 + (15*b3^8 + 640*b3^4)*b2^4 + (6*b3^10 - 192*b3^6 + 256*b3^2)*b2^2 + b3^12);

if(D==2,(P(b1,b2,b3)=b1-1/2*(b2^2+b3^2)));
if(D==3,(P(x,y,z)=-x^4 - 2*x^2*y^2 + (4*z^2 + 4)*x*y -y^4 - 4*z^2));
if(D==5,(P(x,y,z)=-1/2*(x^4+y^4+z^4+x^4*y^4+x^4*z^4+y^4*z^4)+x*y*z+x^5*y*z+x*y^5*z+x*y*z^5-x^2*y^2*z^2));


if(D%4==1,dsc=D;w=(1+sqrt(D))/2;ww=(1-sqrt(D))/2,dsc=4*D;w=sqrt(D);ww=-w);

if(D==2,bp3=polroots(P(x,bp1,bp2));nb=length(bp3);Omega=vector(nb,i,TauFromBjp(bp3[i],bp1,bp2,MM)),
      bp3=polroots(P(bp1,bp2,x));nb=length(bp3);Omega=vector(nb,i,TauFromBjp(bp1,bp2,bp3[i],MM)));
gam=vector(nb,i,Inverser2(Omega[i],dsc));
Omega2=vector(nb,i,Mtau(gam[i],Omega[i]));

R=[1,w;1,ww];
Tau=vector(nb,i,(R~)^-1*Omega2[i]*R^-1);
z1=vector(nb,i,Tau[i][1,1]);
z2=vector(nb,i,Tau[i][2,2]);

Tab2=[1, 5, 33, 290, 89, 66, 10, 2392, 117, 2871, 31, 1156, 24, 905, 197, 1112, 1172, 4523, 1443, 1442, 131, 473, 461, 523, 1983, 399, 397, 646, 6867, 500, 7074, 2435, 7335, 2341, 670, 327, 8139, 60, 323, 1566, 4094, 192, 4024, 953, 4404, 3755, 162, 1399, 3613, 284, 1395, 5049, 4100, 9275, 4267, 1433, 735, 4451, 3886, 8942, 845, 4375, 745, 5168, 157, 750, 3142, 154, 3092, 9163, 2164, 5382, 2118, 383, 2263, 2356, 6425, 6500, 2386, 6424, 2789, 1872, 666, 2794, 7870, 370, 6222, 6483, 6881, 7327, 2608, 2089, 8118, 1564, 1969, 5939, 2351, 6618, 2029, 1785, 1586, 1587, 1819, 5575, 1592, 5984, 6199, 7414, 3001, 4392, 3018, 4242, 3532, 4241, 4511, 3802, 4447, 9365, 4560, 3462, 5057, 4930, 5147, 9256, 5062, 4830, 9723, 3790, 3906, 4793, 3120, 3979, 3394, 986, 3884, 4059, 4568, 3128, 1307, 3140, 3420, 4182, 8988, 4057, 5405, 5402, 6068, 7043, 6666, 2471, 7468, 6895, 2040, 7882, 2696, 8025, 8105, 7004, 7780, 6893, 6641, 5527, 2050, 438, 6082, 2139, 5300, 2634, 6180, 5981, 5951, 5876, 8384, 9049, 4578, 1218, 8952, 4126, 3904, 4928, 9148, 8881, 8147, 4703, 984, 4822, 3457, 2469, 7776, 6034, 1746, 3403];

Tab3=[1, 5, 88, 290, 221, 66, 81, 4436, 117, 5172, 205, 2370, 24, 1895, 78, 4216, 2377, 10097, 2870, 5171, 317, 198, 2226, 1162, 7100, 904, 1880, 1389, 4114, 2241, 9859, 7351, 10095, 3359, 2868, 731, 5169, 324, 728, 3465, 2158, 1082, 6731, 4286, 7099, 6057, 897, 2777, 1873, 1396, 2774, 6419, 2175, 5744, 7044, 5060, 2611, 7350, 5628, 5474, 1972, 5806, 3625, 2866, 747, 1555, 6116, 341, 744, 2490, 6039, 2094, 10800, 1045, 3614, 3980, 1590, 4908, 4285, 8574, 3653, 4513, 9042, 1583, 894, 2791, 5043, 8654, 1412, 2788, 3786, 9360, 4248, 9095, 3256, 10118, 139, 8205, 10414, 4796, 3009, 3071, 4335, 8607, 5100, 129, 1878, 2903, 6249, 781, 4825, 9082, 8372, 780, 196, 3986, 9419, 220, 8570, 6234, 7177, 654, 8651, 7778, 7854, 6476, 6284, 7375, 5597, 1659, 644, 3119, 5387, 3134, 2816, 7872, 5667, 5226, 2815, 474, 7049, 5391, 527, 11041, 1656, 10116, 342, 132, 10114, 1894, 1548, 4332, 319, 2, 1398, 203, 3628, 1871, 8608, 1089, 470, 6350, 526, 10096, 6347, 3611, 7172, 1413, 647, 5664, 3055, 3652, 7372, 1391, 16, 326, 490, 5567, 3249, 8162, 487, 1053, 3704, 1165, 5629, 3700, 8, 410, 6349, 45, 168, 3702];


Tab5=[1, 15, 89, 7899, 14, 88, 1709, 10, 7140, 2672, 7839, 105, 12, 6002, 82, 7408, 56, 349, 473, 11011, 507, 2302, 6604, 7898, 320, 11005, 53, 11, 1561, 81, 7081, 629, 2737, 472, 6752, 2383, 7321, 353, 1699, 2712, 5808, 626, 3212, 6991, 11295, 2306, 7132, 2455, 11334, 2380, 7897, 49, 7838, 63, 2621, 5009, 324, 336, 1622, 489, 7457, 596, 2620, 79, 10598, 2364, 7283, 2740, 7945, 352, 10871, 593, 3325, 456, 2103, 7323, 7407, 2305, 11022, 2362, 1698, 622, 348, 635, 7840, 1689, 2716, 2726, 1059, 2151, 6826, 10944, 11098, 1454, 7931, 453, 7131, 418, 2301, 2389, 2454, 7122, 1579, 1354, 270, 10997, 317, 312, 642, 4309, 343, 390, 1846, 1557, 5411, 211, 1582, 2431, 335, 1621, 5580, 331, 2439, 78, 5198, 548, 2453, 2623, 1559, 2739, 5475, 2669, 10360, 2251, 7022, 7286, 7079, 2428, 10828, 545, 7944, 311, 2736, 600, 350, 7939, 1581, 2613, 1044, 6862, 11250, 2107, 6747, 7011, 7755, 2248, 7406, 1951, 7320, 2367, 2303, 4571, 1972, 805, 255, 1693, 1205, 309, 5799, 2731, 2755, 7968, 7019, 327, 1167, 2788, 2287, 2725, 847, 3592, 2723, 156, 6829, 3210, 5401, 8664, 6860, 11068, 308, 7930, 458, 6965, 9846, 1577, 2095, 1161, 7126, 4224, 417, 11331, 7317, 7333, 11061, 7449, 2290, 4201, 1578, 1353, 269, 7470, 1363, 1132, 9931, 60, 1159, 4371, 1524, 5863, 1587, 1665, 5747, 389, 1845, 1630, 385, 9528, 5830, 4836, 7951, 1122, 4279, 2490, 333, 6003, 1618, 9150, 1593, 5616, 260, 1327, 10368, 2219, 6964, 2456, 7455, 2285, 11388, 504, 1558, 2619, 2676, 2738, 876, 2787, 3017, 4099, 3182, 8601, 7025, 11309, 2106, 11076, 2216, 5645, 541, 3203, 554, 7322, 4343, 2442, 1331, 7941, 1121, 310, 10044, 2615, 2636, 5553, 1692, 2719, 1158, 2491, 341, 1043, 1814, 2611, 1372, 8833, 3324, 768, 7437, 3179, 3513, 2244, 1552, 2256, 11296, 5459, 1196, 232, 11372, 3359, 3999, 3208, 7294, 11326, 7125, 6425, 188, 2786, 1293, 254, 7167, 765, 4446, 3141, 632, 229, 1199, 5856, 7845, 9880, 2754, 7967, 4543, 2750, 3876, 9930, 1597, 5575, 4440, 4576, 1973, 2724, 3565, 1057, 3578, 3590, 4116, 2, 19, 3209, 6825, 6864, 3262, 10821, 4218, 1096, 10652, 1519, 7928, 2114, 6761, 7963, 1040, 2094, 844, 7782, 3484, 9895, 2386, 1093, 4220, 2471, 8797, 8736, 7332, 11376, 4946, 7328, 9530, 3319, 4579, 9616, 3482, 7398, 9986, 267, 9676, 9995, 1357, 32, 375, 1785, 3465, 1854, 4955, 4797, 10358, 5555, 2634, 1664, 4010, 6065, 387, 1840, 2321, 332, 6150, 3339, 8852, 3593, 2746, 7950, 7031, 10853, 210, 3314, 1113, 8371, 1617, 4204, 5677, 3110, 6209, 3577, 9147, 6968, 5675, 8510, 4890, 10832, 5014, 2182, 6889, 5860, 5196, 7024, 6989, 7454, 2452, 513, 7284, 7447, 130, 23, 7761, 4439, 3566, 7835, 3149, 8559, 6063, 1813, 228, 2729, 3468, 7953, 7833, 828, 10359, 3326, 7111, 2180, 10458, 1518, 7021, 2223, 2104, 11307, 1114, 215, 8647, 2425, 9842, 2447, 2472, 7482, 6050, 7166, 1092, 2441, 1330, 11089, 2438, 2093, 374, 212, 1117, 5460, 5552, 1655, 2632, 3874, 1690, 885, 3589, 3466, 1547, 2612, 1041, 9145, 3313, 3010, 42, 266, 8829, 7436, 3188, 6827, 8835, 2904, 1081, 5462, 7754, 7032, 11312, 2089, 4096, 1195, 231, 3584, 872, 9626, 371, 1078, 3558, 2324, 11236, 7086, 10814, 3265, 763, 3343, 7123, 4350, 7468, 892, 3137, 10151, 252, 9923, 913, 222, 370, 1780, 1198, 3561, 882, 8798, 8561, 6184, 2752, 7964, 7329, 199, 11434, 3875, 3344, 380, 1596, 5574, 1592, 5679, 939, 3753, 1009, 1056, 191, 3472, 3520, 4746, 9167, 10929, 3624, 140, 9120, 746, 11238, 8662, 11253, 10982, 3196, 4217, 1095, 7479, 7927, 2113, 799, 6737, 9128, 7961, 4071, 7746, 10961, 3576, 6727, 1086, 2153, 3116, 9983, 5299, 2469, 6888, 11262, 2320, 7330, 11375, 11297, 11086, 808, 2315, 3984, 9615, 7091, 3081, 3005, 7422, 6883, 8645, 1356, 9965, 4747, 879, 6896, 9156, 1615, 9076, 510, 5751, 9433, 386, 265, 8602, 10946, 2633, 8810, 1662, 9155, 1839, 9511, 3259, 7194, 11354, 5622, 6205, 8747, 8854, 11065, 11058, 7910, 10679, 10617, 7029, 8845, 8457, 4271, 10470, 1810, 3481, 850, 8553, 2110, 4834, 4811, 10789, 8596, 1091, 717, 10824, 3554, 3303, 2148, 5195, 6994, 7023, 3754, 1171, 7450, 1015, 8820, 2296, 2325, 6823, 2434, 1077, 129, 22, 9617, 139, 1216, 663, 1168, 3756, 9927, 11425, 7923, 8856, 1811, 1206, 4515, 7834, 4097, 3575, 10374, 3020, 39, 251, 7110, 2185, 8828, 9674, 6884, 10923, 10815, 5568, 7013, 214, 4230, 551, 4202, 3327, 7481, 7430, 2467, 8857, 3078, 9924, 7164, 4225, 1328, 7419, 3024, 220, 577, 372, 1116, 7291, 196, 6728, 3340, 9170, 7909, 5833, 1157, 3009, 5570, 1364, 9119, 10922, 802, 8616, 5405, 2903, 1080, 7188, 7753, 4987, 4505, 6730, 7780, 9032, 8381, 1661, 9633, 28, 3625, 11327, 7198, 2322, 7292, 3197, 8629, 3341, 7324, 2463, 7467, 6895, 187, 678, 1295, 10199, 6837, 1836, 7917, 9075, 8552, 2751, 250, 8737, 7843, 11472, 10170, 10447, 3473, 3516, 11494, 10584, 6102, 1594, 8628, 6180, 3335, 8844, 8508, 8528, 1008, 190, 9072, 7028, 9165, 7420, 1076, 18, 8637, 8661, 7418, 10068, 4983, 3194, 7108, 4346, 5301, 2111, 6834, 7960, 8453, 712, 6159, 9151, 10033, 7184, 5648, 11489, 2468, 10279, 4813, 11353, 6880, 8808, 10521, 8594, 7093, 6187, 9408, 9043, 11484, 8554, 11251, 3579, 4547, 1614, 10337, 10152, 10042, 10345, 4306, 8738, 9487, 1837, 8435, 3193, 7193, 4004, 1299, 8746, 8743, 10259, 10616, 10278, 8456, 9565, 9904, 10230, 10495, 1170, 8614, 2155, 20, 9137, 10546, 10142, 9077, 35, 679, 3360, 189, 10456, 730, 10628, 3306, 7092, 133, 1782, 3113, 1050, 10852, 227, 3019, 3588, 10322, 4990, 7187, 4017, 9632, 206, 10636, 3177, 3023, 9994, 10833, 11488, 9118, 11493, 9164, 8454, 8847, 9564, 10231, 6966, 9678, 3328, 3623, 5300, 10369, 3076, 715, 8294, 3268, 10632, 6893, 795, 10196, 1055, 9896, 7477, 8744, 9910, 9485, 11473, 9522, 8556, 6892, 9140, 10344, 11063, 8167, 10530, 11483, 8742, 8807, 8447, 8806, 3570, 9136, 203, 8544, 6835, 9486, 10450, 10453, 7185, 8555, 132, 9139, 8550, 3144, 9434, 9512, 3309];

Tab5M=[8316, 2978, 8412, 290, 8405, 8315, 249, 9377, 1156, 1445, 1444, 3047, 8340, 1347, 8209, 4436, 1291, 1286, 5653, 1112, 954, 4406, 1446, 288, 1324, 5171, 7699, 8404, 1325, 8215, 185, 1401, 4934, 5292, 1075, 4466, 5780, 1292, 247, 289, 4771, 2990, 4094, 2916, 4268, 955, 1154, 1190, 3804, 9344, 5172, 3737, 1441, 8642, 1236, 7118, 9476, 3417, 3440, 2910, 1191, 1237, 4882, 9300, 4216, 1000, 996, 1402, 1345, 248, 5069, 4681, 5791, 4175, 4170, 4467, 4434, 1155, 10095, 6645, 4781, 701, 1282, 2981, 1443, 7276, 8342, 5892, 1808, 3002, 9693, 4269, 1110, 4198, 5150, 11284, 3806, 3730, 4403, 9338, 4493, 9438, 11475, 8170, 7162, 1442, 8992, 2954, 2976, 5168, 4607, 8643, 6383, 4617, 2957, 2566, 8701, 8716, 3425, 8971, 3200, 8990, 8613, 8214, 4199, 4495, 4494, 1238, 1323, 1346, 4618, 8128, 1039, 4244, 9826, 1001, 183, 4435, 3936, 11383, 5071, 2961, 4932, 6398, 1285, 8676, 8706, 3505, 2585, 1683, 10917, 4176, 1073, 1111, 4727, 6013, 10097, 8313, 5779, 5726, 953, 6745, 9477, 9956, 6686, 1283, 6029, 2960, 4763, 2996, 2070, 2021, 5170, 6536, 7773, 9199, 11470, 8023, 1729, 2992, 6095, 2142, 3003, 4092, 4113, 3792, 11343, 8237, 8314, 1432, 10356, 4137, 8361, 10351, 8499, 6051, 4404, 11346, 3738, 3802, 5743, 6959, 6924, 10131, 3953, 11366, 8705, 10297, 6831, 2605, 10837, 584, 5169, 8839, 3441, 7719, 8297, 3686, 1942, 4608, 3474, 6384, 9952, 835, 6431, 3444, 4879, 7272, 8253, 2584, 6904, 10247, 6983, 8656, 3439, 6259, 8639, 7674, 7143, 11017, 4114, 4138, 9808, 4496, 1189, 184, 10132, 3867, 4620, 4880, 3050, 1400, 2068, 8415, 5522, 1757, 4068, 4065, 4245, 4214, 1074, 5060, 7683, 3947, 9326, 992, 9374, 4465, 6556, 9577, 7144, 4933, 7658, 8305, 3447, 4726, 6399, 1941, 4770, 705, 7817, 3240, 7520, 6939, 6358, 7686, 6832, 9274, 5788, 4093, 10090, 11223, 6627, 3972, 1269, 8212, 4267, 10327, 1768, 1779, 9035, 9520, 5473, 3791, 5727, 5240, 3803, 3734, 2038, 9198, 6687, 10984, 1505, 10631, 2627, 4764, 2987, 1772, 1770, 8379, 7280, 1431, 2071, 6594, 4759, 6510, 10332, 1440, 6537, 3198, 2625, 5496, 9471, 1730, 6695, 1806, 1829, 8287, 5894, 6635, 6803, 7721, 4391, 5656, 5766, 7827, 7150, 7158, 1433, 2975, 5147, 11140, 5347, 8229, 6938, 8884, 5948, 6394, 7289, 7535, 8354, 7154, 7152, 11294, 10118, 4481, 6960, 11277, 10037, 11271, 9014, 4490, 2851, 1544, 7287, 7502, 3931, 7160, 2591, 7619, 8172, 7659, 8352, 11471, 8991, 6385, 7349, 1038, 7740, 1943, 6396, 3475, 6818, 6699, 8641, 6432, 6725, 3424, 10874, 9110, 9013, 2991, 2994, 8254, 3244, 8951, 7684, 7105, 9003, 11325, 11291, 2876, 3423, 7735, 8598, 1882, 6140, 11178, 8261, 11254, 8612, 1922, 7083, 7758, 5767, 4139, 4197, 4215, 10760, 8119, 4491, 5456, 995, 10898, 9936, 2056, 3632, 8416, 4616, 5059, 6484, 7245, 5068, 4790, 1773, 5523, 5982, 5383, 5978, 6853, 1037, 5790, 3897, 11469, 9859, 9346, 4924, 11177, 4169, 10493, 3451, 2559, 993, 8145, 3930, 5787, 7531, 10646, 10094, 5355, 7155, 9578, 6035, 2502, 10504, 2661, 10289, 7671, 2583, 1268, 11127, 4819, 6393, 8524, 1281, 2059, 2943, 3103, 6953, 2209, 7717, 7217, 10513, 6951, 7161, 11241, 5789, 10058, 5318, 3001, 1685, 9949, 7254, 1270, 4721, 6675, 5321, 11125, 11000, 8721, 368, 2073, 441, 5474, 11468, 11263, 6672, 2086, 4390, 5241, 8087, 6688, 1469, 11482, 4402, 2562, 7620, 2054, 5380, 8033, 7461, 5352, 6625, 5884, 8324, 8353, 6019, 445, 2065, 5744, 2359, 11144, 6595, 1984, 6923, 1807, 11153, 9109, 8890, 6357, 3199, 11179, 6781, 3420, 5549, 10716, 2053, 5896, 2032, 6093, 2145, 1830, 6501, 5960, 6816, 6813, 410, 1980, 4392, 3790, 2602, 2539, 1652, 11422, 2311, 6962, 5148, 8597, 11379, 3366, 6509, 6463, 6952, 2498, 10414, 6141, 11123, 2875, 8323, 11344, 2212, 6986, 7597, 4482, 7759, 5229, 10669, 6907, 11198, 8062, 10304, 1504, 1545, 8072, 1491, 9938, 11324, 6054, 11395, 991, 10746, 588, 7179, 1883, 7518, 6546, 2595, 1926, 9518, 3476, 10800, 11118, 8171, 4064, 980, 6397, 4822, 4606, 6547, 9784, 839, 10552, 2085, 5715, 8463, 8623, 8503, 8506, 1490, 8195, 6674, 8288, 10334, 8695, 8952, 8881, 8982, 6514, 10357, 7501, 7288, 10774, 10659, 6256, 11501, 5351, 306, 7151, 11016, 7825, 409, 4112, 6632, 9734, 2914, 4243, 5548, 5885, 4492, 6613, 10130, 3896, 5457, 3935, 9329, 7258, 6486, 6804, 1546, 6634, 369, 8308, 5883, 5550, 4923, 3899, 1574, 8936, 6356, 367, 6020, 5983, 1755, 6139, 8289, 5529, 7462, 11216, 979, 9302, 9702, 2598, 11323, 4925, 5058, 6780, 3975, 2567, 2312, 9354, 2874, 1684, 7596, 3926, 7889, 9553, 6744, 5356, 1503, 2310, 7142, 7499, 11322, 8883, 8428, 8838, 11267, 10600, 7687, 11122, 11481, 2944, 8234, 5986, 8490, 7521, 6782, 6830, 408, 9214, 5792, 5319, 7727, 10610, 7259, 5230, 4722, 11224, 6012, 11126, 6392, 5977, 1576, 6692, 6597, 5181, 8011, 5242, 2087, 5455, 5725, 1470, 1651, 8937, 7540, 7745, 7572, 7831, 6633, 5182, 6689, 1492, 1513, 9320, 2795, 1923, 6131, 2020, 6646, 4483, 7244, 3402, 4704, 6462, 1728, 1927, 11479, 6401, 7104, 6535, 5244, 11176, 9028, 8919, 5494, 1986, 10553, 2039, 6248, 6797, 6574, 10864, 11013, 10566, 1653, 10027, 2603, 7617, 11342, 1468, 3892, 2565, 11003, 10658, 1508, 8273, 9060, 11283, 7374, 1828, 6257, 10866, 6346, 5565, 11288, 3403, 10115, 5713, 8063, 10025, 9234, 304, 5442, 5313, 8147, 7500, 5613, 5592, 2538, 1884, 4730, 7700, 6349, 6132, 3454, 1913, 5366, 8896, 9417, 6430, 4323, 5729, 10697, 9016, 11248, 8504, 8482, 10213, 10588, 8949, 9070, 1915, 9067, 6130, 6249, 2626, 5314, 1512, 6670, 6328, 1611, 10952, 1925, 1778, 5176, 2355, 6621, 978, 4319, 5959, 7270, 5443, 6481, 8355, 5495, 1756, 3509, 1769, 1575, 6856, 1924, 3891, 5714, 2035, 6598, 7157, 7725, 305, 7082, 2665, 6347, 11075, 6350, 8466, 6575, 10183, 3460, 6703, 11041, 11232, 2588, 5793, 8010, 7888, 10116, 11222, 5528, 1928, 10209, 7573, 10936, 9667, 5615, 5893, 6247, 7724, 9593, 9065, 3106, 3457, 8920, 5594, 7811, 6330, 1613, 7618, 5179, 3370, 5614, 11476, 8871, 9235, 3458, 2075, 6329, 10609, 1612, 1507, 9418, 8483, 8950, 5228, 5566, 6487, 1914, 6348, 5593, 5567, 4703, 9670];

if(D%4==2,Tab=Tab2);
if(D%4==3,Tab=Tab3);
if(D==5,Tab=Tab5;TabM=Tab5M);


Z=[];
for(k=1,nb,
  test=0;for(i=1,11520,if(test==0&&dansG24(MM[i][1]*gam[k]),test=i));
  if(test==0,print("erreur anormale: gam n'est pas dans Gamma_2 ??"));

  if(D%4!=1,for(i=1,length(Tab),if(Tab[i]==test,Z=concat(Z,[mtauD(M[i],[z1[k],z2[k]],D)]))),
            test2=0;
            for(i=1,length(Tab),if(Tab[i]==test,test=i;test2=1;break));

	    if(test2,Z=concat(Z,[mtauD(M[test],[z1[k],z2[k]],D)]),
               for(i=1,length(TabM),if(TabM[i]==test,test=i;test2=1;break));
               if(test2==0,print("problème: il manque une classe ??"));
	       Z=concat(Z,[mtauD(M[test],[z2[k],z1[k]],D)]))));

return(Z);
}


\\ Rose = invariants de Rosenhaim

\\ D dans {2,3,5}
taufromroseNivD(r1,r2,M,NN,D)=  
{my(P,r3,Omega,gam,Omega2,R,Tau,z1,z2,Z,test,Tab,Tab2,Tab3,dsc,w,ww,nb,x);
x='x;


if(D==2,P(r1,r2,r3)=((16*r3^2 - 16*r3)*r2^2 + (-16*r3^2 + 16*r3)*r2)*r1^4 + ((-16*r3^2 + 16*r3)*r2^3 + (-16*r3^3 + 16*r3^2)*r2^2 + (16*r3^3 - 16*r3)*r2)*r1^3 + (-r2^4 + (16*r3^3 - 16*r3 + 2)*r2^3 + (-14*r3^2 + 14*r3 - 1)*r2^2 + (-16*r3^3 + 14*r3^2 + 2*r3)*r2 + (-r3^4 + 2*r3^3 - r3^2))*r1^2 + (2*r3*r2^4 + (-16*r3^3 + 14*r3^2 - 2*r3)*r2^3 + (14*r3^3 - 12*r3^2)*r2^2 + (2*r3^4 - 2*r3^3)*r2)*r1 + (-r3^2*r2^4 + 2*r3^3*r2^3 - r3^4*r2^2));

if(D==3,P(r1,r2,r3)=r1^8*r2^4*r3^4-4*r1^8*r2^4*r3^3+6*r1^8*r2^4*r3^2-4*r1^8*r2^4*r3+r1^8*r2^4-4*r1^7*r2^5*r3^4-16*r1^7*r2^5*r3^3+40*r1^7*r2^5*r3^2-16*r1^7*r2^5*r3-4*r1^7*r2^5+160*r1^7*r2^4*r3^4-160*r1^7*r2^4*r3^3-160*r1^7*r2^4*r3^2+160*r1^7*r2^4*r3-132*r1^7*r2^3*r3^5-272*r1^7*r2^3*r3^4+808*r1^7*r2^3*r3^3-272*r1^7*r2^3*r3^2-132*r1^7*r2^3*r3+384*r1^7*r2^2*r3^5-384*r1^7*r2^2*r3^4-384*r1^7*r2^2*r3^3+384*r1^7*r2^2*r3^2-256*r1^7*r2*r3^5+512*r1^7*r2*r3^4-256*r1^7*r2*r3^3+6*r1^6*r2^6*r3^4+40*r1^6*r2^6*r3^3+164*r1^6*r2^6*r3^2+40*r1^6*r2^6*r3+6*r1^6*r2^6-160*r1^6*r2^5*r3^4-352*r1^6*r2^5*r3^3-352*r1^6*r2^5*r3^2-160*r1^6*r2^5*r3-272*r1^6*r2^4*r3^5+1344*r1^6*r2^4*r3^4-608*r1^6*r2^4*r3^3+1344*r1^6*r2^4*r3^2-272*r1^6*r2^4*r3+384*r1^6*r2^3*r3^6-416*r1^6*r2^3*r3^5-480*r1^6*r2^3*r3^4-480*r1^6*r2^3*r3^3-416*r1^6*r2^3*r3^2+384*r1^6*r2^3*r3-762*r1^6*r2^2*r3^6+1064*r1^6*r2^2*r3^5-348*r1^6*r2^2*r3^4+1064*r1^6*r2^2*r3^3-762*r1^6*r2^2*r3^2+384*r1^6*r2*r3^6-384*r1^6*r2*r3^5-384*r1^6*r2*r3^4+384*r1^6*r2*r3^3-4*r1^5*r2^7*r3^4-16*r1^5*r2^7*r3^3+40*r1^5*r2^7*r3^2-16*r1^5*r2^7*r3-4*r1^5*r2^7-160*r1^5*r2^6*r3^4-352*r1^5*r2^6*r3^3-352*r1^5*r2^6*r3^2-160*r1^5*r2^6*r3+808*r1^5*r2^5*r3^5-608*r1^5*r2^5*r3^4+3696*r1^5*r2^5*r3^3-608*r1^5*r2^5*r3^2+808*r1^5*r2^5*r3-384*r1^5*r2^4*r3^6-480*r1^5*r2^4*r3^5-2208*r1^5*r2^4*r3^4-2208*r1^5*r2^4*r3^3-480*r1^5*r2^4*r3^2-384*r1^5*r2^4*r3-256*r1^5*r2^3*r3^7+1064*r1^5*r2^3*r3^6-608*r1^5*r2^3*r3^5+3696*r1^5*r2^3*r3^4-608*r1^5*r2^3*r3^3+1064*r1^5*r2^3*r3^2-256*r1^5*r2^3*r3+384*r1^5*r2^2*r3^7-416*r1^5*r2^2*r3^6-480*r1^5*r2^2*r3^5-480*r1^5*r2^2*r3^4-416*r1^5*r2^2*r3^3+384*r1^5*r2^2*r3^2-132*r1^5*r2*r3^7-272*r1^5*r2*r3^6+808*r1^5*r2*r3^5-272*r1^5*r2*r3^4-132*r1^5*r2*r3^3+r1^4*r2^8*r3^4-4*r1^4*r2^8*r3^3+6*r1^4*r2^8*r3^2-4*r1^4*r2^8*r3+r1^4*r2^8+160*r1^4*r2^7*r3^4-160*r1^4*r2^7*r3^3-160*r1^4*r2^7*r3^2+160*r1^4*r2^7*r3-272*r1^4*r2^6*r3^5+1344*r1^4*r2^6*r3^4-608*r1^4*r2^6*r3^3+1344*r1^4*r2^6*r3^2-272*r1^4*r2^6*r3-384*r1^4*r2^5*r3^6-480*r1^4*r2^5*r3^5-2208*r1^4*r2^5*r3^4-2208*r1^4*r2^5*r3^3-480*r1^4*r2^5*r3^2-384*r1^4*r2^5*r3+512*r1^4*r2^4*r3^7-348*r1^4*r2^4*r3^6+3696*r1^4*r2^4*r3^5+1496*r1^4*r2^4*r3^4+3696*r1^4*r2^4*r3^3-348*r1^4*r2^4*r3^2+512*r1^4*r2^4*r3-384*r1^4*r2^3*r3^7-480*r1^4*r2^3*r3^6-2208*r1^4*r2^3*r3^5-2208*r1^4*r2^3*r3^4-480*r1^4*r2^3*r3^3-384*r1^4*r2^3*r3^2-272*r1^4*r2^2*r3^7+1344*r1^4*r2^2*r3^6-608*r1^4*r2^2*r3^5+1344*r1^4*r2^2*r3^4-272*r1^4*r2^2*r3^3+160*r1^4*r2*r3^7-160*r1^4*r2*r3^6-160*r1^4*r2*r3^5+160*r1^4*r2*r3^4+r1^4*r3^8-4*r1^4*r3^7+6*r1^4*r3^6-4*r1^4*r3^5+r1^4*r3^4-132*r1^3*r2^7*r3^5-272*r1^3*r2^7*r3^4+808*r1^3*r2^7*r3^3-272*r1^3*r2^7*r3^2-132*r1^3*r2^7*r3+384*r1^3*r2^6*r3^6-416*r1^3*r2^6*r3^5-480*r1^3*r2^6*r3^4-480*r1^3*r2^6*r3^3-416*r1^3*r2^6*r3^2+384*r1^3*r2^6*r3-256*r1^3*r2^5*r3^7+1064*r1^3*r2^5*r3^6-608*r1^3*r2^5*r3^5+3696*r1^3*r2^5*r3^4-608*r1^3*r2^5*r3^3+1064*r1^3*r2^5*r3^2-256*r1^3*r2^5*r3-384*r1^3*r2^4*r3^7-480*r1^3*r2^4*r3^6-2208*r1^3*r2^4*r3^5-2208*r1^3*r2^4*r3^4-480*r1^3*r2^4*r3^3-384*r1^3*r2^4*r3^2+808*r1^3*r2^3*r3^7-608*r1^3*r2^3*r3^6+3696*r1^3*r2^3*r3^5-608*r1^3*r2^3*r3^4+808*r1^3*r2^3*r3^3-160*r1^3*r2^2*r3^7-352*r1^3*r2^2*r3^6-352*r1^3*r2^2*r3^5-160*r1^3*r2^2*r3^4-4*r1^3*r2*r3^8-16*r1^3*r2*r3^7+40*r1^3*r2*r3^6-16*r1^3*r2*r3^5-4*r1^3*r2*r3^4+384*r1^2*r2^7*r3^5-384*r1^2*r2^7*r3^4-384*r1^2*r2^7*r3^3+384*r1^2*r2^7*r3^2-762*r1^2*r2^6*r3^6+1064*r1^2*r2^6*r3^5-348*r1^2*r2^6*r3^4+1064*r1^2*r2^6*r3^3-762*r1^2*r2^6*r3^2+384*r1^2*r2^5*r3^7-416*r1^2*r2^5*r3^6-480*r1^2*r2^5*r3^5-480*r1^2*r2^5*r3^4-416*r1^2*r2^5*r3^3+384*r1^2*r2^5*r3^2-272*r1^2*r2^4*r3^7+1344*r1^2*r2^4*r3^6-608*r1^2*r2^4*r3^5+1344*r1^2*r2^4*r3^4-272*r1^2*r2^4*r3^3-160*r1^2*r2^3*r3^7-352*r1^2*r2^3*r3^6-352*r1^2*r2^3*r3^5-160*r1^2*r2^3*r3^4+6*r1^2*r2^2*r3^8+40*r1^2*r2^2*r3^7+164*r1^2*r2^2*r3^6+40*r1^2*r2^2*r3^5+6*r1^2*r2^2*r3^4-256*r1*r2^7*r3^5+512*r1*r2^7*r3^4-256*r1*r2^7*r3^3+384*r1*r2^6*r3^6-384*r1*r2^6*r3^5-384*r1*r2^6*r3^4+384*r1*r2^6*r3^3-132*r1*r2^5*r3^7-272*r1*r2^5*r3^6+808*r1*r2^5*r3^5-272*r1*r2^5*r3^4-132*r1*r2^5*r3^3+160*r1*r2^4*r3^7-160*r1*r2^4*r3^6-160*r1*r2^4*r3^5+160*r1*r2^4*r3^4-4*r1*r2^3*r3^8-16*r1*r2^3*r3^7+40*r1*r2^3*r3^6-16*r1*r2^3*r3^5-4*r1*r2^3*r3^4+r2^4*r3^8-4*r2^4*r3^7+6*r2^4*r3^6-4*r2^4*r3^5+r2^4*r3^4);

if(D==5,P(r1,r2,r3)=(r3^2*r2^2 - 2*r3^2*r2 + r3^2)*r1^4 + ((-2*r3^2 + 2*r3)*r2^3 - 2*r3^2*r2^2 + (2*r3^3 + 4*r3^2 - 2*r3)*r2 - 2*r3^3)*r1^3 + ((r3^2 - 2*r3 + 1)*r2^4 + (4*r3^2 - 2*r3 - 2)*r2^3 + (-4*r3^2 + 4*r3 + 1)*r2^2 - 2*r3^3*r2 + r3^4)*r1^2 + ((-2*r3^3 + 2*r3)*r2^3 + (4*r3^3 - 2*r3^2 - 2*r3)*r2^2 + (-2*r3^4 + 2*r3^3)*r2)*r1 + (r3^4 - 2*r3^3 + r3^2)*r2^2);


if(D%4==1,dsc=D;w=(1+sqrt(D))/2;ww=(1-sqrt(D))/2,dsc=4*D;w=sqrt(D);ww=-w);


r3=polroots(P(r1,r2,x));nb=length(r3);Omega=vector(nb,i,TauFromRose(r1,r2,r3[i],NN));
gam=vector(nb,i,Inverser2(Omega[i],dsc));
Omega2=vector(nb,i,Mtau(gam[i],Omega[i]));

R=[1,w;1,ww];
Tau=vector(nb,i,(R~)^-1*Omega2[i]*R^-1);
z1=vector(nb,i,Tau[i][1,1]);
z2=vector(nb,i,Tau[i][2,2]);

Tab2=[1, 5, 3, 143, 11, 46, 220, 72, 258, 105, 20, 93, 118, 384, 141, 18, 51, 197, 44, 70, 218, 40, 43, 42, 103, 116, 140, 139, 102, 84, 90, 88, 217, 216, 256, 254, 194, 192, 170, 382, 380, 435, 345, 302, 580, 495, 482, 658];

Tab3=[1, 5, 10, 143, 25, 46, 373, 72, 438, 205, 20, 177, 210, 465, 257, 37, 109, 317, 92, 135, 280, 16, 79, 78, 24, 363, 68, 248, 247, 55, 151, 38, 2, 154, 176, 54, 514, 316, 136, 14, 427, 275, 112, 326, 8, 184, 33, 96];


if(D==2,Tab=Tab2);
if(D==3,Tab=Tab3);


Z=[];
for(k=1,nb,
  test=0;for(i=1,length(NN),if(test==0&&dansG22(NN[i][1]*gam[k]),test=i));
  if(test==0,print("erreur anormale: gam n'est pas dans Gamma_2 ??"));
  for(i=1,length(Tab),if(Tab[i]==test,Z=concat(Z,[mtauD(M[i],[z1[k],z2[k]],D)]))));

\\ajouter conjugué 

return(Z);

}


mtauD(M,Z,D)=
{my(a,b,c,d,aa,bb,cc,dd,w,ww,x);
x='x;
if(D%4==1,w=(1+sqrt(D))/2;ww=(1-sqrt(D))/2,w=sqrt(D);ww=-w);

[a,b,c,d]=[subst(lift(M[1,1]),x,w),subst(lift(M[1,2]),x,w),subst(lift(M[2,1]),x,w),subst(lift(M[2,2]),x,w)];
[aa,bb,cc,dd]=[subst(lift(M[1,1]),x,ww),subst(lift(M[1,2]),x,ww),subst(lift(M[2,1]),x,ww),subst(lift(M[2,2]),x,ww)];
return([(a*Z[1]+b)/(c*Z[1]+d),(aa*Z[2]+bb)/(cc*Z[2]+dd)]);
}


PhiGamD(M,D)=
{my(R,S,w,a,x);
x='x;
if(D%4==1,a=Mod(x,x^2-x-(D-1)/4);w=(1+sqrt(D))/2,a=Mod(x,x^2-D);w=sqrt(D));
R=[1,a;1,conj(a)];
S=matconcat([R~,0;0,R^-1]);
return(subst(lift(S*matconcat([[M[1,1],0;0,conj(M[1,1])],[M[1,2],0;0,conj(M[1,2])];[M[2,1],0;0,conj(M[2,1])],[M[2,2],0;0,conj(M[2,2])]])*S^-1),x,w));
}




\\ fct pour tester si tau est bien dans espace de Humbert
TestNiv5(tau)=return(tau[1,1]-tau[2,2]+tau[1,2]);
TestNiv2(tau)=return(tau[1,1]-tau[2,2]+2*tau[1,2]);
TestNiv3(tau)=return(3*tau[1,1]-tau[2,2]);
TestNivD(tau,D)={if(D%4==1,return((D-1)/4*tau[1,1]+tau[1,2]-tau[2,2]),return(D*tau[1,1]-tau[2,2]));}

/************************************************************************************************************/
/************************************************************************************************************/


\\ polgund et polthet : évaluation des polynômes modulaires


\\ D=5
mtau(M,Z)= \\vrai si M ne contient pas de sqrt(5)
{return([(M[1,1]*Z[1]+M[1,2])/(M[2,1]*Z[1]+M[2,2]),0;0,(M[1,1]*Z[2]+M[1,2])/(M[2,1]*Z[2]+M[2,2])]);}


\\ D=5, Gundlach, beta*betac=l
polgund(Z,l,beta,betac)=
{my(X,M,z,ValJ,Phi,Psi);
X='X;

M=concat(vector(l,i,[1,i-1;0,1]),[[0,-1;1,0]]);   \\ isogénies

ValJ=concat(vector(l+1,i,z=[1/beta,0;0,1/betac]*mtau(M[i],Z);JGundlach([z[1,1],z[2,2]])),
            vector(l+1,i,z=[1/betac,0;0,1/beta]*mtau(M[i],Z);JGundlach([z[1,1],z[2,2]])));

Phi=prod(i=1,2*(l+1),X-ValJ[i][1]);
Psi=sum(i=1,2*(l+1),ValJ[i][2]*divrem(Phi,X-ValJ[i][1])[1]);

return([vector(2*(l+1)+1,i,polcoeff(Phi,i-1,X)),vector(2*(l+1)+1,i,polcoeff(Psi,i-1,X))]);
}

\\ D=5, l inerte, M pour les isogénies Sl2(OK)/G_0(l)
polgundInerte(Z,l,M)=
{my(X,z,ValJ,Phi,Psi,J2,J4);
X='X;

ValJ=vector(l^2+1,i,z=mtau5(M[i],Z);[J2,J4]=JGundlach([z[1]/l,z[2]/l]);[J2,J4]);
Phi=prod(i=1,l^2+1,X-ValJ[i][1]);
Psi=sum(i=1,l^2+1,ValJ[i][2]*divrem(Phi,X-ValJ[i][1])[1]);

return([vector(l^2+2,i,polcoeff(Phi,i-1,X)),vector(l^2+2,i,polcoeff(Psi,i-1,X))]);
}




polgundNiv2(Z,l,beta,betac,L1,L2)=
{my(X,M,z,ValJ,Phi,Psi,J1,J3);
X='X;

M=concat(vector(l,i,[1,i-1;0,1]),[[0,-1;1,0]]);

ValJ=concat(vector(l+1,i,z=[1/beta,0;0,1/betac]*mtau(M[i],Z);[J1,J3]=JGundlachNiv2([z[1,1],z[2,2]],L1,L2);[J1,J3]), 
            vector(l+1,i,z=[1/betac,0;0,1/beta]*mtau(M[i],Z);[J1,J3]=JGundlachNiv2([z[1,1],z[2,2]],L1,L2);[J1,J3]));
Phi=prod(i=1,2*(l+1),X-ValJ[i][1]);
Psi=sum(i=1,2*(l+1),ValJ[i][2]*divrem(Phi,X-ValJ[i][1])[1]);

return([vector(2*(l+1)+1,i,polcoeff(Phi,i-1,X)),vector(2*(l+1)+1,i,polcoeff(Psi,i-1,X))]);
}


\\ Cas où l est inerte

polgundNiv2Inerte(Z,l,L1,L2,M)=
{my(X,z,ValJ,Phi,Psi,J1,J3);
X='X;

ValJ=vector(l^2+1,i,z=mtau2(M[i],Z);[J1,J3]=JGundlachNiv2([z[1]/l,z[2]/l],L1,L2);[J1,J3]);
Phi=prod(i=1,l^2+1,X-ValJ[i][1]);
Psi=sum(i=1,l^2+1,ValJ[i][2]*divrem(Phi,X-ValJ[i][1])[1]);

return([vector(l^2+2,i,polcoeff(Phi,i-1,X)),vector(l^2+2,i,polcoeff(Psi,i-1,X))]);
}


polthetNiv2(Z,l,beta,betac,M)= 
{my(X,z,ValB,Phi,Psi,M0,x);
X='X;
x='x;

M0=[Mod(-x+1,x^2-2),0;Mod(2,x^2-2),Mod(-x-1,x^2-2)];

ValB=concat(vector(length(M),i,z=mtau2(M[i],Z);EvalBjp(TauToOmegaNiv2([z[1]/beta,z[2]/betac]))), 
            vector(length(M),i,z=mtau2(M[i]*M0,[Z[2],Z[1]]);EvalBjp(TauToOmegaNiv2([z[1]/beta,z[2]/betac]))));   
\\            vector(l+1,i,z=mtau2(conj(M[i]),Z);[b1,b2,b3]=EvalBjp(TauToOmegaNiv2([z[1]/betac,z[2]/beta])))); 


Phi=prod(i=1,2*length(M),X-ValB[i][1]);
Psi=sum(i=1,2*length(M),ValB[i][2]*divrem(Phi,X-ValB[i][1])[1]);

return([vector(2*length(M)+1,i,polcoeff(Phi,i-1,X)),vector(2*length(M)+1,i,polcoeff(Psi,i-1,X))]);
}



polthetNiv5(Z,l,beta,betac,M)= 
{my(X,z,ValB,Phi,Psi2,Psi3);
X='X;

ValB=vector(l+1,i,z=mtau5(M[i],Z);EvalBjp(TauToOmegaNiv5([z[1]/beta,z[2]/betac]))); 

Phi=prod(i=1,(l+1),X-ValB[i][1]);
Psi2=sum(i=1,(l+1),ValB[i][2]*divrem(Phi,X-ValB[i][1])[1]);
Psi3=sum(i=1,(l+1),ValB[i][3]*divrem(Phi,X-ValB[i][1])[1]);

return([vector((l+1)+1,i,polcoeff(Phi,i-1,X)),vector((l+1)+1,i,polcoeff(Psi2,i-1,X)),vector((l+1)+1,i,polcoeff(Psi3,i-1,X))]);
}



polthetNiv3(Z,l,beta,betac,M)= 
{my(X,z,ValB,Phi,Psi2,Psi3);
X='X;

ValB=concat(vector(l+1,i,z=mtau3(M[i],Z);EvalBjp(TauToOmegaNiv3([z[1]/beta,z[2]/betac]))),
	    vector(l+1,i,z=mtau3(M[i],[Z[2],Z[1]]);EvalBjp(TauToOmegaNiv3([z[1]/beta,z[2]/betac]))));


Phi=prod(i=1,2*(l+1),X-ValB[i][1]);
Psi2=sum(i=1,2*(l+1),ValB[i][2]*divrem(Phi,X-ValB[i][1])[1]);
Psi3=sum(i=1,2*(l+1),ValB[i][3]*divrem(Phi,X-ValB[i][1])[1]);

return([vector(2*(l+1)+1,i,polcoeff(Phi,i-1,X)),vector(2*(l+1)+1,i,polcoeff(Psi2,i-1,X)),vector(2*(l+1)+1,i,polcoeff(Psi3,i-1,X))]);
}


polthetNivD(Z,beta,betac,MCl,D)= 
{my(X,z,ValB,Phi,Psi2,Psi3);
X='X;

if(D%4==1,
   ValB=vector(length(MCl),i,z=mtauD(MCl[i],Z,D);EvalBjp(TauToOmega([z[1]/beta,z[2]/betac],D))),
   ValB=concat(vector(length(MCl),i,z=mtauD(MCl[i],Z,D);EvalBjp(TauToOmega([z[1]/beta,z[2]/betac],D))),
               vector(length(MCl),i,z=mtauD(MCl[i],[Z[2],Z[1]],D);EvalBjp(TauToOmega([z[1]/beta,z[2]/betac],D)))));

if(D==2,
  Phi=prod(i=1,length(ValB),X-ValB[i][2]);
  Psi2=sum(i=1,length(ValB),ValB[i][3]*divrem(Phi,X-ValB[i][2])[1]);
  return([vector(length(ValB)+1,i,polcoeff(Phi,i-1,X)),vector(length(ValB)+1,i,polcoeff(Psi2,i-1,X))]),

  Phi=prod(i=1,length(ValB),X-ValB[i][1]);
  Psi2=sum(i=1,length(ValB),ValB[i][2]*divrem(Phi,X-ValB[i][1])[1]);
  Psi3=sum(i=1,length(ValB),ValB[i][3]*divrem(Phi,X-ValB[i][1])[1]);
  return([vector(length(ValB)+1,i,polcoeff(Phi,i-1,X)),vector(length(ValB)+1,i,polcoeff(Psi2,i-1,X)),vector(length(ValB)+1,i,polcoeff(Psi3,i-1,X))]));
}



polthetNiv2Inerte(Z,l,MCl,D)= 
{my(X,z,ValB,Phi,Psi2,Psi3);
X='X;

ValB=vector(length(MCl),i,z=mtauD(MCl[i],Z,D);EvalBjp(TauToOmega([z[1]/l,z[2]/l],D)));
Phi=prod(i=1,length(ValB),X-ValB[i][2]);
Psi2=sum(i=1,length(ValB),ValB[i][3]*divrem(Phi,X-ValB[i][2])[1]);
return([vector(length(ValB)+1,i,polcoeff(Phi,i-1,X)),vector(length(ValB)+1,i,polcoeff(Psi2,i-1,X))]);
}


polthetNivDInerte(Z,l,MCl,D)=
{my(X,z,ValB,Phi,Psi2,Psi3);
X='X;

ValB=vector(length(MCl),i,z=mtauD(MCl[i],Z,D);EvalBjp(TauToOmega([z[1]/l,z[2]/l],D)));
Phi=prod(i=1,length(ValB),X-ValB[i][1]);
Psi2=sum(i=1,length(ValB),ValB[i][2]*divrem(Phi,X-ValB[i][1])[1]);
Psi3=sum(i=1,length(ValB),ValB[i][3]*divrem(Phi,X-ValB[i][1])[1]);
return([vector(length(ValB)+1,i,polcoeff(Phi,i-1,X)),vector(length(ValB)+1,i,polcoeff(Psi2,i-1,X)),vector(length(ValB)+1,i,polcoeff(Psi3,i-1,X)\
)]);
}



polRoseNivD(Z,beta,betac,MCl,D)= 
{my(X,z,ValB,Phi,Psi2,Psi3);
X='X;

if(D%4==1,
   ValB=vector(length(MCl),i,z=mtauD(MCl[i],Z,D);Rosenhain(TauToOmega([z[1]/beta,z[2]/betac],D))),
   ValB=concat(vector(length(MCl),i,z=mtauD(MCl[i],Z,D);Rosenhain(TauToOmega([z[1]/beta,z[2]/betac],D))),
               vector(length(MCl),i,z=mtauD(MCl[i],[Z[2],Z[1]],D);Rosenhain(TauToOmega([z[1]/beta,z[2]/betac],D)))));

Phi=prod(i=1,length(ValB),X-ValB[i][1]);
Psi2=sum(i=1,length(ValB),ValB[i][2]*divrem(Phi,X-ValB[i][1])[1]);
Psi3=sum(i=1,length(ValB),ValB[i][3]*divrem(Phi,X-ValB[i][1])[1]);

return([vector(length(ValB)+1,i,polcoeff(Phi,i-1,X)),vector(length(ValB)+1,i,polcoeff(Psi2,i-1,X)),vector(length(ValB)+1,i,polcoeff(Psi3,i-1,X))]);
}



\\ Deux fonctions  Inverser: la première que pour D=2,5 et l'autre pour tout D. 
\\ Elles Ne correspondent pas à la même application de Hilbert à Humbert

Inverser(Om,disc)=
{my(u,m,v,a,b,c,d,e,a1,c1,e1,e2,a3,c3,a4,b4,c4,b5,p,test,alpha,beta,n,
gam,delta,eps,et,mu,nu,tau,g0,g1,g2,g3,g4,R0,R1,R2,R3,R4,R5,M,M0,M1,M2,M3,M4,M4p,M5,J);


u=[Om[1,1],Om[1,2],Om[2,2],Om[1,2]^2-Om[1,1]*Om[2,2],1];
m=matid(5);
m[5,]=real(u)*10^200;
v=round(qflll(m));
test=0;
for(i=1,5,if(v[2,i]^2-4*v[1,i]*v[3,i]-4*v[4,i]*v[5,i]==disc,test=i));
if(test==0||abs(u*v[,test])>10^-100,print("erreur3"));


[a,b,c,d,e]=v[,test];
R0=[0,a,0,d;-c,b,-d,0;0,e,0,-c;-e,0,a,b];


\\ Step I
[alpha,beta,g0]=bezout(e,c);
\\beta=-beta;	
alpha=-alpha;
g0=-g0;

M0=[1,0,1,0;0,alpha,0,beta;-1,0,0,0;0,c/g0,0,e/g0];
R1=(M0~)^-1*R0*M0~;

a1=R1[1,2];
\\b1=R1[2,2];
c1=-R1[2,1];
e1=R1[3,2];

\\ Step II
g1=gcd(a1,e1);
p=nextprime(abs(c1)+1);
test=0;
while(test!=1,if((p*g1-e1)%a1==0,test=1;n=(p*g1-e1)/a1,p=nextprime(p+1)));
M1=matconcat([matid(2),[-n,0;0,0];0,matid(2)]);
R2=(M1~)^-1*R1*(M1~);
e2=R2[3,2];

\\ Step III
[gam,delta,g2]=bezout(e2,c1);
\\delta=-delta;
gam=-gam;
g2=-g2;

M2=[gam*a1/g2,0,1,0;0,gam,0,delta;-1,0,0,0;0,c1/g2,0,e2/g2];
R3=(M2~)^-1*R2*(M2~);
a3=R3[1,2];
\\b3=R3[2,2];
c3=-R3[2,1];

\\ Step IV
[eps,et,g3]=bezout(a3,c3);

eps=-eps;
et=-et;
g3=-g3;

M3=[1,0,1,0;0,c3/g3,0,-a3/g3;-eps*a3/g3,0,et*c3/g3,0;0,eps,0,et];
R4=(M3~)^-1*R3*(M3~);
b4=R4[2,2];
c4=-R4[2,1];
a4=R4[1,2]/c4;


\\ Step V
[mu,nu,g4]=-bezout((a4+1)*c4+b4,c4);

M4=[1,0,1,0;0,c4/g4,0,(-(a4+1)*c4-b4)/g4;-mu*((a4+1)*c4+b4)/g4,0,nu*c4/g4,0;0,mu,0,nu];
M4p=[1,0,0,0;-1,1,0,0;0,0,1,1;0,0,0,1];
R5=((M4*M4p)~)^-1*R4*((M4*M4p)~)+c4*matid(4);

\\a5=R5[1,2];
b5=R5[2,2];


\\ Step VI
if(b5%2==0,tau=(b5-2)/2,tau=(b5-1)/2);

M5=[1,0,0,0;-tau,1,0,0;0,0,1,tau;0,0,0,1];
\\R6=(M5~)^-1*R5*(M5~)-tau*matid(4);
\\k=R6[1,2];
\\l=R6[2,2];

M=M5*M4*M4p*M3*M2*M1*M0;
J=[0,0,-1,0;0,0,0,-1;1,0,0,0;0,1,0,0];

if(M~*J*M!=J,print("erreur4"));

return(M);
}




Inverser2(Om,disc)=
{my(u,m,v,a,b,c,d,e,a1,c1,e1,e2,a3,c3,a4,b4,c4,b5,p,test,alpha,beta,n,
gam,delta,eps,et,mu,nu,tau,g0,g1,g2,g3,R0,R1,R2,R3,R4,R5,M,M0,M1,M2,M3,M4,M4p,M5,J,N);


u=[Om[1,1],Om[1,2],Om[2,2],Om[1,2]^2-Om[1,1]*Om[2,2],1];
m=matid(5);
m[5,]=real(u)*10^200;
v=round(qflll(m));
test=0;
for(i=1,5,if(v[2,i]^2-4*v[1,i]*v[3,i]-4*v[4,i]*v[5,i]==disc,test=i));
if(test==0||abs(u*v[,test])>10^-100,print("erreur3"));


[a,b,c,d,e]=v[,test];
R0=[0,a,0,d;-c,b,-d,0;0,e,0,-c;-e,0,a,b];


\\ Step I
[alpha,beta,g0]=gcdext(e,c);
beta=-beta;	

M0=[1,0,1,0;0,alpha,0,beta;-1,0,0,0;0,c/g0,0,e/g0];
R1=(M0~)^-1*R0*M0~;

a1=R1[1,2];
\\b1=R1[2,2];
c1=-R1[2,1];
e1=R1[3,2];

\\ Step II
g1=gcd(a1,e1);
p=nextprime(abs(c1)+1);
test=0;
while(test!=1,if((p*g1-e1)%a1==0,test=1;n=(p*g1-e1)/a1,p=nextprime(p+1)));
M1=matconcat([matid(2),[-n,0;0,0];0,matid(2)]);
R2=(M1~)^-1*R1*(M1~);
e2=R2[3,2];

\\ Step III
[gam,delta,g2]=gcdext(e2,c1);
delta=-delta;
M2=[gam*a1/g2,0,1,0;0,gam,0,delta;-1,0,0,0;0,c1/g2,0,e2/g2];
R3=(M2~)^-1*R2*(M2~);
a3=R3[1,2];
\\b3=R3[2,2];
c3=-R3[2,1];

\\ Step IV
[eps,et,g3]=gcdext(a3,c3);
M3=[1,0,1,0;0,c3/g3,0,-a3/g3;-eps*a3/g3,0,et*c3/g3,0;0,eps,0,et];
R4=(M3~)^-1*R3*(M3~);
b4=R4[2,2];
c4=-R4[2,1];
a4=R4[1,2]/c4;


\\ Step V
[mu,nu]=bezout((a4+1)*c4+b4,c4)[1..2];
M4=[1,0,1,0;0,c4,0,-(a4+1)*c4-b4;-mu*((a4+1)*c4+b4),0,nu*c4,0;0,mu,0,nu];
M4p=[1,0,0,0;-1,1,0,0;0,0,1,1;0,0,0,1];
R5=((M4*M4p)~)^-1*R4*((M4*M4p)~)+c4*matid(4);

\\a5=R5[1,2];
b5=R5[2,2];


\\ Step VI
if(b5%2==0,tau=b5/2,tau=(b5-1)/2);

M5=[1,0,0,0;tau,1,0,0;0,0,1,-tau;0,0,0,1];
\\R6=(M5~)^-1*R5*(M5~)-tau*matid(4);

M=M5*M4*M4p*M3*M2*M1*M0;
J=[0,0,-1,0;0,0,0,-1;1,0,0,0;0,1,0,0];

if(M~*J*M!=J,print("erreur4"));

if(disc%4!=0,N=[1,0,0,0;0,-1,0,0;0,0,1,0;0,0,0,-1],N=matid(4));
return(N*M);
}

