

/*
Fonctions pour 
-tester appartenance à un groupe;
-obtenir les générateurs d'un certain groupe;
-calculer des quotients: ComputeFDAndGenerators (voir thèse de Dupont).
*/


dansG2(M)=
{my(J);
J=[0,0,-1,0;0,0,0,-1;1,0,0,0;0,1,0,0];
return(M~*J*M==J);
}

dansG22(M)={return(M%2==matid(4));}

dansG24(M)=
{\\if(dansG2(M)==0,print("erreur: la matrice n'est pas dans G2"));
return(\\dansG2(M)&&
       M%2==matid(4)&&
       M[1,3]%4==0&&
       M[2,4]%4==0&&
       M[3,1]%4==0&&
       M[4,2]%4==0);
}


genG2()=
{my(J,M1,M2,M3);
J=[0,0,-1,0;0,0,0,-1;1,0,0,0;0,1,0,0];
M1=[1,0,1,0;0,1,0,0;0,0,1,0;0,0,0,1];
M2=[1,0,0,0;0,1,0,1;0,0,1,0;0,0,0,1];
M3=[1,0,0,1;0,1,1,0;0,0,1,0;0,0,0,1];
return([J,M1,M2,M3]);
}

genGb()=
{my(sig1,sig2,sig3,sig4,sig5,sig6,sig7,sig8,sig9);
sig1=[1,0,2,0;0,1,0,0;0,0,1,0;0,0,0,1];
sig2=[1,0,0,0;0,1,0,2;0,0,1,0;0,0,0,1];
sig3=[1,0,0,1;0,1,1,0;0,0,1,0;0,0,0,1];
sig4=[1,0,0,0;0,1,0,0;4,0,1,0;0,0,0,1];
sig5=[1,0,0,0;0,1,0,0;0,0,1,0;0,4,0,1];
sig6=[1,0,0,0;0,1,0,0;0,2,1,0;2,0,0,1];
sig7=[1,0,0,0;0,-1,0,0;0,0,1,0;0,0,0,-1];
sig8=[3,0,2,0;0,3,0,2;4,0,3,0;0,4,0,3];
sig9=[1,2,0,0;-2,-3,0,0;0,0,-3,2;0,0,-2,1];
return([sig1,sig2,sig3,sig4,sig5,sig6,sig7,sig8,sig9]);
}


genSLO2()=my(x);x='x;return([[1,1;0,1],[0,-1;1,0],[1,Mod(x,x^2-2);0,1]]);
genSLO5()=my(x);x='x;return([[1,1;0,1],[0,-1;1,0],[1,Mod(x,x^2-x-1);0,1]]);
genSLO3()=my(x);x='x;return([[1,1/2;0,1],[1,Mod(1/(2*x),x^2-3);0,1],[0,Mod(-1/(2*x),x^2-3);Mod(2*x,x^2-3),0]]);
genSLOD(D)=
{my(dsc,x,w);
x='x;
if(D%4==1,dsc=Mod(2*x-1,x^2-x-(D-1)/4);w=Mod(x,x^2-x-(D-1)/4),dsc=Mod(2*x,x^2-D);w=Mod(x,x^2-D));
return([[1,1/dsc;0,1],[1,w/dsc;0,1],[0,-1/dsc;dsc,0]]);
}


dansSLG2(M)={return(lift(lift(M[1,1]*Mod(1,2)))==1&&lift(lift(M[2,2]*Mod(1,2)))==1&&lift(lift(M[1,2]*Mod(1,2)))==0&&lift(lift(M[2,1]*Mod(1,2)))==0);}

dansSLThNiv2(M)={return(dansSLG2(M)&&(polcoeff(lift(M[1,2]),0)+polcoeff(lift(M[1,2]),1))%4==0&&(polcoeff(lift(M[2,1]),0)+polcoeff(lift(M[2,1]),1))%4==0);}

dansSLThNiv5(M)={return(lift(lift(M[1,1]*Mod(1,2)))==1&&lift(lift(M[2,2]*Mod(1,2)))==1&&lift(lift(M[1,2]*Mod(1,4)))==0&&lift(lift(M[2,1]*Mod(1,4)))==0);}

dansSLG0B(M)={return(type(polcoeff(lift(M[1,2]/Beta),1))=="t_INT"&&type(polcoeff(lift(M[1,2]/Beta),0))=="t_INT");}

dansSLG4(M)={return(lift(lift(M[1,1]*Mod(1,4)))==1&&lift(lift(M[2,2]*Mod(1,4)))==1&&lift(lift(M[1,2]*Mod(1,4)))==0&&lift(lift(M[2,1]*Mod(1,4)))==0);}

gamB(M)={return([M[1,1],M[1,2]/Beta;M[2,1]*Beta,M[2,2]]);}

dansSLThNiv3(M)={my(x);x='x;return(lift(lift(M[1,1]*Mod(1,2)))==1&&lift(lift(M[2,2]*Mod(1,2)))==1&&lift(lift((Mod(2*x,x^2-3)*M[1,2])*Mod(1,2)))==0&&lift(lift((Mod(1/2/x,x^2-3)*M[2,1])*Mod(1,2)))==0&&
polcoeff(lift(lift((Mod(2*x,x^2-3)*M[1,2])*Mod(1,4))),1)==0&&polcoeff(lift(lift((Mod(1/2/x,x^2-3)*M[2,1])*Mod(1,4))),1)==0);}

dansSLG0BNiv3(M)={my(x);x='x;return(type(polcoeff(lift(Mod(2*x,x^2-3)*M[1,2]/Beta),1))=="t_INT"&&type(polcoeff(lift(Mod(2*x,x^2-3)*M[1,2]/Beta),0))=="t_INT");}
dansSL03(M)={my(x);x='x;return(type(polcoeff(lift(M[1,1]),0))=="t_INT"&&type(polcoeff(lift(M[1,1]),1))=="t_INT"&&
	            type(polcoeff(lift(M[2,2]),0))=="t_INT"&&type(polcoeff(lift(M[2,2]),1))=="t_INT"&&
	            type(polcoeff(lift(Mod(2*x,x^2-3)*M[1,2]),0))=="t_INT"&&type(polcoeff(Mod(2*x,x^2-3)*lift(M[1,2]),1))=="t_INT"&&
	            type(polcoeff(lift(Mod(1/(2*x),x^2-3)*M[2,1]),0))=="t_INT"&&type(polcoeff(Mod(1/(2*x),x^2-3)*lift(M[2,1]),1))=="t_INT");}


dansSLThNivD(M,D)=
{my(dsc,x);
x='x;
if(D%4==1,dsc=Mod(2*x-1,x^2-x-(D-1)/4),dsc=Mod(2*x,x^2-D));
if(D%4==1,return(lift(lift(M[1,1]*Mod(1,2)))==1&&lift(lift(M[2,2]*Mod(1,2)))==1&&lift(lift(dsc*M[1,2]*Mod(1,4)))==0&&lift(lift(1/dsc*M[2,1]*Mod(1,4)))==0),
return(lift(lift(M[1,1]*Mod(1,2)))==1&&lift(lift(M[2,2]*Mod(1,2)))==1&&lift(lift((dsc*M[1,2])*Mod(1,2)))==0&&lift(lift((1/dsc*M[2,1])*Mod(1,2)))==0&&
       polcoeff(lift(lift((dsc*M[1,2])*Mod(1,4))),1)==0&&polcoeff(lift(lift((1/dsc*M[2,1])*Mod(1,4))),1)==0));
}

dansSLG0BNivD(M,D)=
{my(x,dsc);
x='x;
if(D%4==1,dsc=Mod(2*x-1,x^2-x-(D-1)/4),dsc=Mod(2*x,x^2-D));

return(type(polcoeff(lift(dsc*M[1,2]/Beta),1))=="t_INT"&&type(polcoeff(lift(dsc*M[1,2]/Beta),0))=="t_INT");
}

dansSLG0lNivD(M,l,D)=
{my(x,dsc);
x='x;
if(D%4==1,dsc=Mod(2*x-1,x^2-x-(D-1)/4),dsc=Mod(2*x,x^2-D));

return(type(polcoeff(lift(dsc*M[1,2]/l),1))=="t_INT"&&type(polcoeff(lift(dsc*M[1,2]/l),0))=="t_INT");
}


dansSLG4D(M,D)=
{my(dsc,x);
x='x;
if(D%4==1,dsc=Mod(2*x-1,x^2-x-(D-1)/4),dsc=Mod(2*x,x^2-D));
return(lift(lift(M[1,1]*Mod(1,4)))==1&&lift(lift(M[2,2]*Mod(1,4)))==1&&lift(lift(dsc*M[1,2]*Mod(1,4)))==0&&lift(lift(1/dsc*M[2,1]*Mod(1,4)))==0);
}



dansSLG2NivD(M,D)=
{my(dsc,x);
x='x;
if(D%4==1,dsc=Mod(2*x-1,x^2-x-(D-1)/4),dsc=Mod(2*x,x^2-D));
return(lift(lift(M[1,1]*Mod(1,2)))==1&&lift(lift(M[2,2]*Mod(1,2)))==1&&lift(lift(dsc*M[1,2]*Mod(1,2)))==0&&lift(lift(1/dsc*M[2,1]*Mod(1,2)))==0);
}



dansSLG2442NivD(M,D)=
{my(dsc,x);
x='x;
if(D%4==1,dsc=Mod(2*x-1,x^2-x-(D-1)/4),dsc=Mod(2*x,x^2-D));
return(lift(lift(M[1,1]*Mod(1,2)))==1&&lift(lift(M[2,2]*Mod(1,2)))==1&&lift(lift(dsc*M[1,2]*Mod(1,4)))==0&&lift(lift(1/dsc*M[2,1]*Mod(1,4)))==0);
}


retirer(L,M)=
{my(N,test);
N=[];
for(i=1,length(L),
   test=1;
   for(j=1,length(M),
      if(test==1&&L[i]==M[j],test=0));
   if(test==1,N=concat(N,[L[i]]));
);
return(N);
}	



ComputeFDAndGenerators(fct,Gam)=
{my(S,D,V,G,t,gam,L);
S=[matid(matsize(Gam[1])[1])];
D=[matid(matsize(Gam[1])[1])];
V=Gam;
G=[];

while(length(V)!=0,
   gam=V[1];
   t=1;
   for(i=1,length(S),
      if(fct(S[i]*gam^-1),
         t=0;
	 G=concat(G,[S[i]*gam^-1])
        )
     );
   if(t==1,
      S=concat(S,[gam]);
      L=vector(length(Gam),i,gam*Gam[i]);
      V=concat(V,retirer(L,D)));
   V=retirer(V,[gam]);
   D=concat(D,[gam]);
   if(length(S)%10==0,print(length(S)));
);

return([S,G]);
}


